ScrnArray = 16384

dim wrow%(mw%),wrows%(mw%),wcol%(mw%),wcols%(mw%),wattr%(mw%),wbrdr%(mw%)
dim wshdw%(mw%),scrn%(ScrnArray),wptr(mw%)

sub MakeWindow(Row%,Col%,Rows%,Cols%,Attr%,BrdrSel%,Shadow%,Zoom%) static
  shared wrow%(),wrows%(),wcol%(),wcols%(),wattr%(),wbrdr%(),wshdw%(),scrn%(),wptr(),LI
  local r1%,r2%,c1%,c2%,colratio%,wsize
  select case shadow%
    Rem Left
    case = 1
      c1%=col%-2 : c2%=cols%+2 : r2%=rows%+1
    Rem Right
    case = 2
      c1%=col%   : c2%=cols%+2 : r2%=rows%+1
    case else
      c1%=col%   : c2%=cols%   : r2%=rows%
  end select
  wsize = (r2% * c2%) * 2
  LI = LI + 1
  Wptr(LI+1) = Wptr(LI)+WSize+1
  WRow%(LI)  = Row%
  WCol%(LI)  = Col%
  WRows%(LI) = Rows%
  WCols%(LI) = Cols%
  Wattr%(LI) = Attr%
  WBrdr%(LI) = BrdrSel%
  WShdw%(LI) = Shadow%
  Call Qsave(Row%,c1%,r2%,c2%,scrn%(Wptr(LI)))
  if zoom% = 1 then
    r1% = row% +       (rows%\2)
    r2% = row% + rows%-(rows%\2)
    c1% = col% +       (cols%\2)
    c2% = col% + cols%-(cols%\2)
    colratio% = (cols% \ rows%)+1
    if colratio% > 4 then colratio%=4
    do
      if r1%>row%         then r1%=r1%-1
      if r2%<(row%+rows%) then r2%=r2%+1
      if c1%>col%         then c1%=c1%-colratio%
      if c1%<col%         then c1%=col%
      if c2%<(col%+cols%) then c2%=c2%+colratio%
      if c2%>(col%+cols%) then c2%=col%+cols%
      call Qbox(r1%,c1%,r2%-r1%,c2%-c1%,attr%,brdrsel%)
    loop until c1%=col% and c2%=col%+cols% and r1%=row% and r2%=row%+rows%
  else
    call Qbox(row%,col%,rows%,cols%,attr%,brdrsel%)
  end if
  select case shadow%
    rem Left
    case = 1
      call qfill(row%+1    ,col%-2    ,rows%-1,2    ,asc(" "),0)
      call qfill(row%+rows%,col%-2    ,1      ,cols%,asc(" "),0)
    rem Right
    case = 2
      call qfill(row%+1    ,col%+cols%,rows%-1,2    ,asc(" "),0)
      call qfill(row%+rows%,col%+2    ,1      ,cols%,asc(" "),0)
    case else
  end select
end sub

sub TitleWindow(dir%,title$) static
shared wrow%(),wcol%(),wrows%(),wcols%(),wattr%(),LI
  select case dir%
    rem UpperLeft
    case = 1
      call qprint(wrow%(LI),wcol%(LI)+2,title$,wattr%(LI))
    rem UpperCenter
    case = 2
      call qprintc(wrow%(LI),wcol%(LI),wcol%(LI)+wcols%(LI)-1,title$,wattr%(LI))
    rem UpperRight
    case = 3
      call qprint(wrow%(LI),wcol%(LI)+wcols%(LI)-len(title$)-2,title$,wattr%(LI))
    rem LowerLeft
    case = 4
      call qprint(wrow%(LI)+wrows%(LI)-1,wcol%(LI)+2,title$,wattr%(LI))
    rem LowerCenter
    case = 5
      call qprintc(wrow%(LI)+wrows%(LI)-1,wcol%(LI),wcol%(LI)+wcols%(LI)-1,title$,wattr%(LI))
    rem LowerRight
    case = 6
      call qprint(wrow%(LI)+wrows%(LI)-1,wcol%(LI)+wcols%(LI)-len(title$)-2,title$,wattr%(LI))
    case else
  end select
end sub

sub RemoveWindow static
shared Wrow%(),WCol%(),WRows%(),Wcols%(),Wattr%(),WShdw%(),Scrn%(),Wptr(),LI
  if LI = 0 then
    print "NO WINDOW TO REMOVE"
  else
    select case WShdw%(LI)
    case = 1
      call qrest(Wrow%(LI),WCol%(LI)-2,WRows%(LI)+1,WCols%(LI)+2,Scrn%(Wptr(LI)))
    case = 2
      call qrest(WRow%(LI),WCol%(LI)  ,WRows%(LI)+1,WCols%(LI)+2,Scrn%(Wptr(LI)))
    case else
      call qrest(WRow%(LI),Wcol%(LI)  ,WRows%(LI)  ,WCols%(LI)  ,Scrn%(Wptr(LI)))
    end select
    LI = LI -1
  end if
end sub

sub Qbox(Row%,Col%,Rows%,Cols%,attr%,BrdrSel%) static
  if rows%>2 and cols%>2 then
    if brdrsel% > 0 and brdrsel% < 6 then
      on brdrsel% gosub single,double,mixed12,mixed21,doubleleftarrow
      call qprint(row%        ,col%        ,tl$                     ,attr%)
      call qfill (row%        ,col%+1      ,1      ,cols%-2,asc(th$),attr%)
      call qprint(row%        ,col%+cols%-1,tr$                     ,attr%)
      call qfill (row%+1      ,col%        ,rows%-2,1      ,asc(lv$),attr%)
      call qfill (row%+1      ,col%+cols%-1,rows%-2,1      ,asc(rv$),attr%)
      call qprint(row%+rows%-1,Col%        ,bl$                     ,attr%)
      call qfill (row%+rows%-1,Col%+1      ,1      ,cols%-2,asc(bh$),attr%)
      call qprint(row%+rows%-1,col%+cols%-1,br$                     ,attr%)
      call qfill (row%+1      ,col%+1      ,rows%-2 ,cols%-2,asc(" "),attr%)
    else
      call qfill (row%,col%,rows%,cols%,asc(" "),attr%)
    end if
  end if
  exit sub

Single:
  TL$=CHR$(218):TH$=CHR$(196):TR$=CHR$(191)
  LV$=CHR$(179):RV$=CHR$(179)
  BL$=CHR$(192):BH$=CHR$(196):BR$=CHR$(217)
  Return
Double:
  TL$=CHR$(201):TH$=CHR$(205):TR$=CHR$(187)
  LV$=CHR$(186):RV$=CHR$(186)
  BL$=CHR$(200):BH$=CHR$(205):BR$=CHR$(188)
  Return
Mixed12:
  TL$=CHR$(214):TH$=CHR$(196):TR$=CHR$(183)
  LV$=CHR$(186):RV$=CHR$(186)
  BL$=CHR$(211):BH$=CHR$(196):BR$=CHR$(189)
  Return
Mixed21:
  TL$=CHR$(213):TH$=CHR$(205):TR$=CHR$(184)
  LV$=CHR$(179):RV$=CHR$(179)
  BL$=CHR$(212):BH$=CHR$(205):BR$=CHR$(190)
  Return
DoubleLeftArrow:
  TL$=CHR$(17):TH$=CHR$(205):TR$=CHR$(187)
  LV$=CHR$(186):RV$=CHR$(186)
  BL$=CHR$(200):BH$=CHR$(205):BR$=CHR$(188)
  Return
end sub

sub ClearWindow static
shared wrow%(),wcol%(),wrows%(),wcols%(),wattr%(),LI
   call qfill (wrow%(LI)+1,wcol%(LI)+1,wrows%(LI)-2,wcols%(LI)-2,asc(" "),wattr%(LI))
end sub

sub PrtWindow(row%,col%,StrDat$) static
shared wrow%(),wcol%(),wrows%(),wcols%(),wattr%(),LI
   call qprint(wrow%(LI)+row%,wcol%(LI)+col%,StrDat$,wattr%(LI))
end sub

sub PrtCWindow(row%,StrDat$) static
shared wrow%(),wcol%(),wrows%(),wcols%(),wattr%(),LI
   call qprintc(wrow%(LI)+row%,wcol%(LI),wcol%(LI)+wcols%(LI),StrDat$,wattr%(LI))
end sub

Sub Scrollup (FIL%,COL%,FILS%,COLS%,FORE%,BACK%,NUMFILS%)
   local ATR%
   ATR%=(back%*16)+fore%
   if fore%>15 then ATR% = ATR% + 112
   Reg 1, 1536+NUMFILS% 'AH=06h
   AL=NUMFILS%
   Reg 2, ATR%*256 'BH=ATR%
   Reg 3, (FIL%-1)*256+COL%-1 ' CH=FIL%
   Reg 4, (FIL%+FILS%-2)*256+COL%+COLS%-2 ' DH=Fila Inferior, DL=Columna izquierda
   Call interrupt &h10 'Llama a la BIOS
End sub

Sub Scrolldw (FIL%,COL%,FILS%,COLS%,FORE%,BACK%,NUMFILS%)
   local ATR%
   ATR%=(back%*16)+fore%
   if fore%>15 then ATR% = ATR% + 112
   Reg 1, 1792+NUMFILS% 'AH=07h
   AL=NUMFILS%
   Reg 2, ATR%*256 'BH=ATR%
   Reg 3, (FIL%-1)*256+COL%-1 ' CH=FIL%
   Reg 4, (FIL%+FILS%-2)*256+COL%+COLS%-2 ' DH=Fila Inferior, DL=Columna izquierda
   Call interrupt &h10 'Llama a la BIOS
End sub

def fnattr%(fore%,back%)
  local temp%
  temp%=(back%*16)+fore%
  if fore%>15 then temp% = temp% + 112
  fnattr% = temp%
end def

SUB QPRINT INLINE
  $INLINE "QPRINT.BIN"
END SUB
rem CALL QPRINT(ROW%,COL%,STR$,ATTR%)

SUB QPRINTC INLINE
  $INLINE "QPRINTC.BIN"
END SUB
rem CALL QPRINTC(ROW%,COLL%,COLR%,STRDAT$,ATTR%)

SUB QFILL INLINE
  $INLINE "QFILL.BIN"
END SUB
rem CALL QFILL(ROW%,COL%,ROWS%,COLS%,CHAR%,ATTR%)

SUB QATTR INLINE
  $INLINE "QATTR.BIN"
END SUB
rem CALL QATTR(ROW%,COL%,ROWS%,COLS%,ATTR%)

SUB QSAVE INLINE
  $INLINE "QSAVE.BIN"
END SUB
rem CALL QSAVE(ROW%,COL%,ROWS%,COLS%,SCRN%(??))

SUB QREST INLINE
  $INLINE "QREST.BIN"
END SUB
rem CALL QREST(ROW%,COL%,ROWS%,COLS%,SCRN%(??))

sub makemenu static
shared wrow%(),wrows%(),wcol%(),wcols%(),wattr%(),wbrdr%(),wshdw%(),scrn%(),wptr(),LI
shared mrow%,mcol%,mwidth%,mattr%,mhiattr%,mbrdrsel%,mshadow%,mzoom%,mtitle$
shared item$(),itemcount%,startpos%
shared curntpos%
call makewindow(mrow%,mcol%,itemcount%+2,mwidth%,mattr%,mbrdrsel%,mshadow%,mzoom%)
call titlewindow(2,mtitle$)
for mloop% = 1 to itemcount%
  call qprintc(wrow%(LI)+mloop%,wcol%(LI),wcol%(LI)+wcols%(LI),item$(mloop%),wattr%(LI))
next
if curntpos% = 0 then if startpos% = 0 then curntpos% = 1 else curntpos% = startpos%
tryagain:
call qattr(wrow%(LI)+curntpos%,wcol%(LI)+1,1,wcols%(LI)-2,mhiattr%)
while not instat
wend
ans$=inkey$
if len(ans$)=2 then ans$=right$(ans$,1)
call qattr(wrow%(LI)+curntpos%,wcol%(LI)+1,1,wcols%(LI)-2,wattr%(LI))
select case ans$
  case chr$(72),chr$(75),"-","8","4"
    decr curntpos%
  case chr$(80),chr$(77),"+","2","6"
    incr curntpos%
  case chr$(13)
    call removewindow
    exit sub
  case chr$(27)
    curntpos%=0
    call removewindow
    exit sub
  case else
    curntpos% = curntpos%
end select
if curntpos% > itemcount% then curntpos% = 1
if curntpos% < 1 then curntpos% = itemcount%
goto tryagain
end sub

Sub Amplia (Y%,X%,TEXTO$,ATRI%,Bloque$)
Local Car%,Byte%,Bit%;Valor%,Codigo%
yini%=y%
xini%=x%
Def Seg=&hf000
Color Color1%,Color2%
For car%=0 to len(texto$)-1
	Car$=mid$(texto$,car%+1,1)
	Codigo%=asc(car$)
		For byte%=0 to 7
		Valor%=peek(&hfa6e+byte%+codigo%*8)
			For bit%=0 to 7			
			If valor%<127 then
                                call qprint (y%+byte%,x%+car%*8+bit%," ",ATRI%)
				else
                                call qprint (y%+byte%,x%+car%*8+bit%,bloque$,ATRI%)
				Valor%=valor%-128
				End if
			Valor%=valor%*2
			Next bit%
		Next byte%
	Next car%
Def Seg
Exit Sub
End Sub

Sub Tecla
Shared i$
Tecla:
I$=INKEY$
IF I$="" THEN GOTO TECLA
EXIT SUB
END SUB


Sub Luces (Y%,X%,Atri%)
LOCAL LUCES%
DEF SEG=&H40
LUCES%=PEEK(&H17):IF LUCES%>127 THEN LUCES%=LUCES%-128:INS%=1 ELSE INS%=0
DEF SEG
if LUCES%=0   THEN MAY%=0:DESP%=0:NUM%=0
if LUCES%=16  THEN MAY%=0:DESP%=0:NUM%=1
IF LUCES%=32  THEN MAY%=0:DESP%=1:NUM%=0
IF LUCES%=48  THEN MAY%=0:DESP%=1:NUM%=1
IF LUCES%=64  THEN MAY%=1:DESP%=0:NUM%=0
IF LUCES%=80  THEN MAY%=1:DESP%=0:NUM%=1
IF LUCES%=96  THEN MAY%=1:DESP%=1:NUM%=0
IF LUCES%=112 THEN MAY%=1:DESP%=1:NUM%=1
IF DESP%=1 THEN CALL QPRINT (Y%,X%+12,"DESP",ATRI%)
IF NUM%=1  THEN CALL QPRINT (Y%,X%+8,"NUM",ATRI%)
IF MAY%=1  THEN CALL QPRINT (Y%,X%+4,"MAY",ATRI%)
IF INS%=1  THEN CALL QPRINT (Y%,X%,"INS",ATRI%)
IF DESP%=0 THEN CALL QPRINT (Y%,X%+12,"   ",ATRI%)
IF NUM%=0  THEN CALL QPRINT (Y%,X%+8,"   ",ATRI%)
IF MAY%=0  THEN CALL QPRINT (Y%,X%+4,"   ",ATRI%)
IF INS%=0  THEN CALL QPRINT (Y%,X%,"   ",ATRI%)
Exit Sub
End Sub

Sub Ayuda (Y%,X%,YLONG%,XLONG%,ATRI%)
SHARED LAST%,TECLA$,I$,AYUDA$()
LOCAL Z%,C%,F%,INI%
Z%=0:CALL MAKEWINDOW (Y%,X%,YLONG%,XLONG%,ATRI%,2,2,1)
Ayuda1:
FOR Z%=Y%+1 TO YLONG%+Y%-1:CALL QPRINT (Z%,X%+XLONG%-2,"",FNATTR%(15,3)):NEXT Z%:Z%=0
CALL QPRINT (Z%+4,72,"",FNATTR%(15,3))
C%=4:FOR F%=INI% TO INI%+12:CALL QPRINT (C%,X%+2,AYUDA$(F%),FNATTR%(15,2)):C%=C%+1:NEXT F%
Ayuda2:
Call Tecla
IF I$=CHR$(27) THEN CALL REMOVEWINDOW:EXIT SUB
IF I$="8" THEN INI%=INI%-1:GOTO Ayuda3
IF I$="2" THEN INI%=INI%+1:GOTO Ayuda3
IF I$="3" THEN INI%=INI%+13:GOTO Ayuda3
IF I$="9" THEN INI%=INI%-13:GOTO Ayuda3
IF I$="1" THEN INI%=LAST%
IF I$="7" THEN INI%=0
Goto Ayuda2
Ayuda3:
IF INI%<0 THEN INI%=0
IF INI%>LAST% THEN INI%=LAST%
CALL QPRINT (Z%+4,72,"",FNATTR%(15,3))
Z%=CINT ((INI%/LAST%)*13)
CALL QPRINT (Z%+4,72,"",FNATTR%(15,3))
GOTO Ayuda1
End Sub

Sub Boton (Y%,X%,TEXTO$,ATRI1%,ATRI2%,ACTI%)
LOCAL TOTAL%
TOTAL%=LEN(TEXTO$)
IF ACTI%=0 THEN
CALL QPRINT (Y%,X%,TEXTO$+CHR$(220),ATRI1%)
CALL QPRINT (Y%+1,X%+1,STRING$(TOTAL%,223),ATRI2%)
EXIT SUB
END IF
IF ACTI%=1 THEN
CALL QPRINT (Y%,X%,TEXTO$+CHR$(32),ATRI1%)
CALL QPRINT (Y%+1,X%+1,STRING$(TOTAL%,32),ATRI2%)
EXIT SUB
END IF
END SUB

Sub Busca (TEMA$,FICHERO$)
LOCAL A$
TEMA$="@"+TEMA$
CLOSE #3
OPEN"I",#3,FICHERO$
LAST%=0
Busca1:
LINE INPUT #3,A$
IF ASC(A$)<58 THEN MAXIMO%=VAL(A$) ELSE MAXIMO%=0
Busca2:
LINE INPUT #3,A$
IF A$="#" THEN CLOSE #3:EXIT SUB 'NO ENCONTRADO
IF A$=TEMA$ THEN GOTO BUSCA3
GOTO BUSCA2
Busca3:
INPUT #1,A$
IF A$="@" THEN CLOSE #3:EXIT SUB 'ENCONTRADO
AYUDA$(LAST%)=A$
GOTO BUSCA3
end sub

Sub Tutorial (Y%,X%,YLONG%,XLONG%,ATRI1%,ATRI2%,FICHERO$) ' NO FUNCIONA
CLOSE #3
OPEN FICHERO$ FOR BINARY AS #3
FIELD #1,1 AS A$
Long%=Lof(3)
F%=1
VID%=0
XMAX%=X%+XLONG%-2
YMAX%=Y%+YLONG%-1
X%=X%+2
Y%=Y%+1
XMIN%=X%
YMIN%=Y%
CALL MAKEWINDOW (Y%,X%,YLONG%,XLONG%,ATRI1%,2,2,1)
Tutorial1:
GET$ #3,F%,A$
IF A$=CHR$(255) AND VIDEO%=1 THEN VIDEO%=0:GOTO TUTORIAL1
IF A$=CHR$(255) AND VIDEO%=0 THEN VIDEO%=1:GOTO TUTORIAL1
IF VIDEO%=1 THEN CALL QPRINT (Y%,X%,A$,ATRI2%) ELSE CALL QPRINT (Y%,X%,A%,ATRI1%)
X%=X%+1
EXIT SUB
END SUB

Sub Carga.Scr (Fichero$)
Def Seg=&hb800
Bload fichero$,0
Def Seg
Exit Sub
End Sub

Sub Graba.Scr (Fichero$)
Def Seg=&hb800
Bsave fichero$,0,4000
Def Seg
Exit Sub
End Sub

Sub InKbd (Yini%,Xini%,Ylong%,Xlong%,Atri%,Max%)
Shared i$
Local X%,y%,CY%,CX%,t%
Texto$=""
X%=xini%
Y%=Yini%
Locate Y%,X%,1
InKbd1:
Call tecla
if i$=chr$(8) then i$=" ":x%=x%-1
if i$=chr$(13) then goto Inkbd10
i$=ucase$(i$)
if i$="6" then i$=""
if i$="4" then i$="":x%=x%-2
if i$="8" then i$="":y%=y%-1
if i$="2" then i$="":y%=y%+1
if i$="7" then i$="":x%=xini%:y%=ini%
if i$="1" then i$="":y%=yini%+ylong%:x%=xini%+xlong%
if x%<xini% then x%=xini%:y%=y%-1
if y%<yini% then y%=yini%:beep:goto Inkbd1
if x%>=xini%+xlong%-2 then x%=xini%:y%=y%+1
If y%>=yini%+ylong% then beep:y%=yini%+ylong%:goto inkbd1
X%=X%+1
Locate y%,x%+1
Call qprint (y%,x%,i$,atri%)
Goto Inkbd1
Inkbd10:
Locate ,,0
T%=1
Inkbd11:
	For Y%=Yini% to Yini%+Ylong%
	For X%=Xini% to Xini%+Xlong%-2
	If t%<=max% then texto$=texto$+chr$(screen (Y%,X%))
	T%=t%+1
Next X%
next y%
Locate 1,1:print texto$
Exit Sub
End Sub

Sub CurLoc (Y%,X%)
Y%=CSRLIN
X%=POS(A)
Exit Sub
End Sub

Sub Existe (Fichero$,Fichero%)
On error goto Existe1
close #1
Open"i",#1,fichero$
Goto existe2
Existe1:
Close
Fichero%=0:resume existe3
Existe2:
Fichero%=1
Existe3:
On error goto errol
Exit Sub
End Sub

Sub Chg.Atr (YINI%,XINI%,YLONG%,XLONG%,Atri%)
Local ROW%,COL%
DEF SEG=&HB800
FOR ROW%=YINI% TO YINI%+YLONG%
FOR COLUMN%=XINI% TO XINI%+XLONG%
POKE 1+(ROW%-1)*160+(COLUMN%-1)*2,ATRI%
NEXT COLUMN%
NEXT ROW%
DEF SEG
Exit Sub
End Sub

Sub Sube.Todo
Locate 25,1:PRINT
EXIT SUB
END SUB

Sub Errores (Linea%,E%)
Local m$,S$,X%
IF E%=4  THEN M$="No hay ms datos":S$=""
IF E%=6  THEN M$="Desbordamiento":S$=""
IF E%=7  THEN M$="Se acab la memoria para programas":S$="Desintale los programas residentes"
IF E%=9  THEN M$="Fuera de rango":S$=""
IF E%=11 THEN M$="Divisin entre cero":S$=""
IF E%=14 THEN M$="Se acab la memoria para cadenas":S$="Desintale los programas residentes"
IF E%=15 THEN M$="Cadena demasiado larga":S$=""
IF E%=16 THEN M$="Cadena demasiado compleja":S$=""
IF E%=17 THEN M$="Sistema parado":S$=""
IF E%=21 THEN M$="Error no imprimible":S$=""
IF E%=25 THEN M$="Fallo en el perifrico":S$="Revise el perifrico"
IF E%=27 THEN M$="Se acab el papel":S$="Ponga papel en la impresora"
IF E%=28 THEN M$="Error no imprimible":S$=""
IF E%>30 AND E%<50 THEN M$="Error no imprimible":S$=""
IF E%=51 THEN M$="Error interno":S$=""
IF E%=53 THEN M$="Archivo no encontrado":S$="Inserte el disco correcto"
IF E%=56 THEN M$="Error no imprimible":S$=""
IF E%=57 THEN M$="Error de E/S en perifrico":S$="Revise el perifrico"
IF E%=58 THEN M$="El archivo ya existe":S$="Elija otro nombre"
IF E%>58 AND E%<61 THEN M$="Error no imprimible":S$=""
IF E%=61 THEN M$="Disco lleno":S$="Cambie de disco e inserte uno vacio"
IF E%=64 THEN M$="Nombre de archivo no vlido":S$="Elija otro nombre"
IF E%=65 THEN M$="Error no imprimible":S$=""
IF E%=67 THEN M$="Demasiados archivos":S$="Cambie de disco e inserte uno vacio"
IF E%=68 THEN M$="Perifrico no disponible":S$="Revise el perifrico"
IF E%=69 THEN M$="Desborde en el buffer de comunicaciones":S$=""
IF E%=70 THEN M$="Disco protegido contra escritura":S$="Retire la proteccin contra escritura"
IF E%=71 THEN M$="Disco no preparado":S$="Inserte un disco en la unidad y cierre la puerta"
IF E%=72 THEN M$="Error en disco":S$="Revise el disco"
IF E%=74 THEN M$="Cambio de nombre en distintos discos":S$="Elija otro nombre"
IF E%=75 THEN M$="Error al acceder al subdirectorio":S$="Inserte el disco correcto"
IF E%=76 THEN M$="Subdirectorio no encontrado":S$="Inserte el disco correcto"
CALL MAKEWINDOW (10,15,10,50,FNATTR%(14,4),2,2,1)
CALL TITLEWINDOW (1,"[Error]")
CALL PRTCWINDOW (1,"Ocurri el error"+STR$(E%)+"/"+STR$(LINEA%))
CALL PRTCWINDOW (3,M$)
CALL PRTCWINDOW (4,S$)
X%=2
CALL BOTON (16,16,"Abandonar",FNATTR%(0,2),FNATTR%(0,4),0)
CALL BOTON (16,32,"Reintentar",FNATTR%(15,2),FNATTR%(0,4),0)
CALL BOTON (16,48,"Seguir",FNATTR%(0,2),FNATTR%(0,4),0)
ERRORES1:
CALL TECLA
IF I$=CHR$(13) THEN GOTO ERRORES2
IF I$="6" THEN X%=X%+1
IF I$="4" THEN X%=X%-1
IF X%>3 THEN X%=1
IF X%<1 THEN X%=3
CALL BOTON (16,16,"Abandonar",FNATTR%(0,2),FNATTR%(0,4),0)
CALL BOTON (16,32,"Reintentar",FNATTR%(0,2),FNATTR%(0,4),0)
CALL BOTON (16,48,"Seguir",FNATTR%(0,2),FNATTR%(0,4),0)
IF X%=1 THEN CALL BOTON (16,16,"Abandonar",FNATTR%(15,2),FNATTR%(0,4),1)
IF X%=2 THEN CALL BOTON (16,32,"Reintentar",FNATTR%(15,2),FNATTR%(0,4),1)
IF X%=3 THEN CALL BOTON (16,48,"Seguir",FNATTR%(15,2),FNATTR%(0,4),1)
GOTO ERRORES1
ERRORES2:
IF X%=1 THEN RESUME INICIO
IF X%=2 THEN RESUME
IF X%=3 THEN RESUME NEXT
EXIT SUB
END SUB


