/* ͻ */
/*                                                                         */
/*                                                                         */
/*                                                                         */
/*                                                                         */
/*                                                                         */
/*                                                                         */
/*                                                                         */
/*                                                                         */
/*                                                                         */
/*                                                                         */
/*                                                                         */
/*                                                                         */
/*                                                                         */
/*                                                                         */
/*                                                                         */
/*                                                                         */
/*                                                                         */
/*                                                                         */
/*                                                                         */
/*                                                                         */
/*                                                                         */
/*                                                                         */
/* ͼ */


/* BERNARDINO: Poligono regular, e irregular (toro, toro, y toro).           */
/*             Cuando eliges una funcion de la lista, que te la ponga de     */
/*             otro color, y te pregunte si de verdad es la que quieres      */
/* GUTI:       Ratn que no se salga.                                        */
/*             Esborrar figura, y esborrar tot).                             */
/*             En la lista que ponga mas datos de la primitiva (x, y), ...   */
/*             Cuando dibujas figura que te pida un nombre, si no le das pone*/
/*					 	 por defecto como ahora                                        */


/* ------------------------------ Inclusions ------------------------------ */
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <math.h>
#include <dos.h>
#include <bios.h>
#include <alloc.h>
#include <conio.h>
#include <graphics.h>
#include <io.h>

/* ------------------------------- Constants ------------------------------ */
#define PI 3.141592654
#define MAX_VECTOR 1000

#define ID_BUIT							0
#define ID_ARC 							1
#define ID_CIRCUMFERENCIA		2
#define ID_ELIPSE 					3
#define ID_LINIA 						4
#define ID_POLIGONIREG			5
#define ID_POLIGONREG 			6
#define ID_RECTANGLE 				7
#define ID_POLIGONPART			100

/* -------------------------- Funcions de suport -------------------------- */
unsigned int pascal esrata (void);
void pascal mostrarrata (void);
void pascal ocultarrata (void);
void pascal llegirrata (unsigned int *, unsigned int *, unsigned int *);
void pascal guardarrata (unsigned int, unsigned int, unsigned int);
void pascal margerata (unsigned int, unsigned int, unsigned int, unsigned int);
char * pascal puntua (long int);

/* ----------------------- Funcions de baix nivell  ----------------------- */
void pascal entrar (void);
void pascal sortir (unsigned int);
void pascal fons (void);
void pascal caixa (unsigned int, unsigned int, unsigned int, unsigned int, char *);
void pascal estat (char *);
unsigned int pascal vmenu (unsigned int, unsigned int, char [][41], unsigned int, unsigned int);
unsigned int pascal hmenu (unsigned int, unsigned int, char [][21], unsigned int, unsigned int);
void pascal boto (unsigned int, unsigned int, char *);
void pascal cadena (unsigned int, unsigned int, char *, unsigned int);
void pascal numero (unsigned int, unsigned int, int *, int, int, int);
void escriure (unsigned int, unsigned int, unsigned int, unsigned int, char *, ...);
void pascal cursor (int *, int *);
void pascal avis (char *);

/* ------------------------ Funcions d'alt nivell  ------------------------ */
void pascal sobre (void);
void pascal info (void);
void pascal principal (void);
void pascal inserir (void);
void pascal carregarvec (void);
void pascal grabarvec (void);
void pascal carregarraw (void);
void pascal grabarraw (void);
void pascal refrescar (void);
void pascal esborrartot (void);
void pascal ferarc (void);
void pascal fercircumferencia (void);
void pascal ferelipse (void);
void pascal ferlinia (void);
void pascal ferpoligonireg (void);
void pascal ferpoligonreg (void);
void pascal ferrectangle (void);
int pascal triarfigura (void);
void pascal transformar (void);

unsigned int index=0;
struct svector
{
	int id;
	int x1;
	int y1;
	int x2;
	int y2;
	int a1;
	int a2;
	char sim[18];
	unsigned int next;
	unsigned char afes;
} vector[MAX_VECTOR];


/* --------------------------- Funci principal --------------------------- */
void main (void)
{
	entrar();
	fons();
	sobre();
	info();
	esborrartot();
	principal();
	sortir(0);
}

/* ------------------------- Mira si hi ha ratoli ------------------------- */
unsigned int pascal esrata (void)
{
	union REGS r;

	r.x.ax=0;
	int86(0x33, &r, &r);
	if (r.x.ax==0)
		return(0);
	else
		return(r.x.bx);
}

/* -------------------------- Ensenya el ratol --------------------------- */
void pascal mostrarrata (void)
{
	union REGS r;

	r.x.ax=1;
	int86(0x33, &r, &r);
}

/* --------------------------- Oculta el ratol --------------------------- */
void pascal ocultarrata (void)
{
	union REGS r;

	r.x.ax=2;
	int86(0x33, &r, &r);
}

/* ------------------- Llegeix les coordenades del ratol ----------------- */
void pascal llegirrata (unsigned int *x, unsigned int *y, unsigned int *b)
{
	union REGS r;

	r.x.ax=3;
	int86(0x33, &r, &r);
	*b=r.x.bx;
	*x=r.x.cx;
	*y=r.x.dx;
}

/* ------------------- Guarda les coordenades del ratol ------------------ */
void pascal guardarrata (unsigned int x, unsigned int y, unsigned int b)
{
	union REGS r;

	r.x.ax=4;
	r.x.bx=b;
	r.x.cx=x;
	r.x.dx=y;
	int86(0x33, &r, &r);
}

/* ------------------- Guarda les coordenades del ratol ------------------ */
void pascal margerata (unsigned int x1, unsigned int y1, unsigned int x2, unsigned int y2)
{
	union REGS r;

	r.x.ax=7;
	r.x.cx=x1;
	r.x.dx=x2;
	int86(0x33, &r, &r);
	r.x.ax=8;
	r.x.cx=y1;
	r.x.dx=y2;
	int86(0x33, &r, &r);

}


/* ------------------------- Puntua un nmero  ---------------------------- */
char * pascal puntua (long int n)
{
	register unsigned int i, j=0, k=0;
	static char tmp[15], res[20];

	memset(tmp, 0, 15);
	memset(res, 0, 20);
	ltoa(n, tmp, 10);
	if (n<1000)
		return(tmp);
	strrev(tmp);
	for (i=0; i!=strlen(tmp); i++)
	{
		if (j==3)
		{
			j=0;
			res[k]='.';
			k++;
		}
		res[k]=tmp[i];
		j++;
		k++;
	}
	strrev(res);
	return(res);
}

/* ------------ Inicialitza el mode grfic 640x480 16/256 colors  --------- */
void pascal entrar (void)
{
	int driver, mode;

	textattr(15);
	cprintf("Prctica de Geometria Computacional I v1.00 per DOS ");
	textattr(7);
	cputs("[VGA 640x480 16 colors]\r\n");
	delay(250);
	/* 640x480 16 colors */
	driver=VGA;
	mode=VGAHI;
	initgraph (&driver, &mode, "");
	if (graphresult()!=grOk)
		sortir(1);
	if (!esrata())
		sortir(2);
	guardarrata(320, 240, 0);
	margerata(1, 14, 639, 471);
}

/* -------------------------- Surt del programa --------------------------- */
void pascal sortir (unsigned int e)
{
	register unsigned int i;
	char *oldb;
	char sino[][21]={	"Si, vull sortir",
										"No, vull seguir"};


	if (e==0)
	{
		oldb=malloc(imagesize(180, 180, 459, 259));
		if (oldb==0)
			sortir(3);
		getimage(180, 180, 459, 259, oldb);
		caixa(180, 180, 459, 259, "Sortir al OS");
		escriure(200, 200, 0, 15, "Segur que vols sortir del");
		escriure(200, 210, 0, 15, "programa?");
		estat("[Sortir]. Tria el bot desitjat.");
		i=hmenu(190, 239, sino, 2, 17*8);
		putimage(180, 180, oldb, COPY_PUT);
		free(oldb);
		if (i==1)
			return;
		else
		{
			closegraph();
			textattr(15);
			cputs("Prctica de Geometria Computacional I v1.00 per DOS\r\n");
			textattr(2);
			cputs("Tot ha concluit correctament.\r\n");
		}
	}
	else if (e==1)
	{
		closegraph();
		textattr(12);
		cprintf("Error(01): Impossible inicialitzar grfics.\r\n");
	}
	else if (e==2)
	{
		closegraph();
		textattr(12);
		cprintf("Error(02): Impossible inicialitzar ratol.\r\n");
	}
	else if (e==2)
	{
		closegraph();
		textattr(12);
		cprintf("Error(03): Impossible reservar memria.\r\n");
	}
	textattr(7);
	cputs(" \r");
	exit(e);
}

/* ------------------- Dibuixa el fons de la pantalla --------------------- */
void pascal fons (void)
{
	cleardevice();
	setcolor(15);
	setfillstyle(SOLID_FILL, 1);
	bar(0, 0, 639, 12);
	escriure(2, 2, 15, 1, "Prctica de Geometria Computacional I v1.00 per DOS");
	setcolor(7);
	setfillstyle(SOLID_FILL, 7);
	bar(0, 13, 639, 471);
	setcolor(8);
	rectangle(0, 470, 639, 479);
	setcolor(7);
	setfillstyle(SOLID_FILL, 7);
	bar(0, 471, 638, 478);
}

/* --------------------- Actualiza la linia d'estat ----------------------- */
void pascal estat (char *text)
{
	setcolor(8);
	rectangle(0, 470, 639, 479);
	setcolor(7);
	setfillstyle(SOLID_FILL, 7);
	bar(0, 471, 638, 478);
	setcolor(0);
	outtextxy(4, 471, text);
}

/* ---------------------------- Dibuixa un boto --------------------------- */
void pascal boto (unsigned int x, unsigned int y, char *text)
{
	setcolor(0);
	rectangle(x, y, x+(strlen(text)<<3)+4, y+12);
	setcolor(8);
	rectangle(x+1, y+1, x+(strlen(text)<<3)+3, y+11);
	setfillstyle(SOLID_FILL, 7);
	bar(x+2, y+2, x+(strlen(text)<<3)+2, y+10);
	setcolor(0);
	outtextxy(x+3, y+3, text);
}

/* -------------------------- Dibuixa una caixa --------------------------- */
void pascal caixa (unsigned int x1, unsigned int y1, unsigned int x2, unsigned int y2, char *text)
{
	setcolor(15);
	setfillstyle(SOLID_FILL, 1);
	bar(x1+4, y1+4, x2-4, y1+15);
	escriure(x1+6, y1+6, 15, 1, text);
	setcolor(0);
	rectangle(x1, y1, x2, y2);
	rectangle(x1+1, y1+1, x2-1, y2-1);
	setcolor(8);
	rectangle(x1+2, y1+2, x2-2, y2-2);
	rectangle(x1+3, y1+3, x2-3, y2-3);
	setcolor(15);
	setfillstyle(SOLID_FILL, 15);
	bar(x1+4, y1+16, x2-4, y2-4);
}

/* -------------------------- Fa un menu vertical ------------------------- */
unsigned int pascal vmenu (unsigned int x1, unsigned int y1, char menu[][41], unsigned int noptions, unsigned int separation)
{
	register int y, x;
	int tx, ty, l;

	l=strlen(menu[0])-1;
	for (y=0; y!=noptions; y++)
		boto(x1, y1+y*separation, menu[y]);
	y=-1;
	do
	{
		cursor(&tx, &ty);
		if ((tx>=x1) && (tx<=(x1+(l<<3))))
		{
			x=(ty-y1)/separation;
			if ((x>=0) && (x<noptions))
				y=x;
		}
	}
	while (y==-1);
	return(y);
}

/* ------------------------- Fa un menu horitzontal ----------------------- */
unsigned int pascal hmenu (unsigned int x1, unsigned int y1, char menu[][21], unsigned int noptions, unsigned int separation)
{
	register int y, x;
	int tx, ty;

	for (x=0; x!=noptions; x++)
		boto(x1+x*separation, y1, menu[x]);
	x=-1;
	do
	{
		cursor(&tx, &ty);
		if ((ty>=y1) && (ty<=y1+8))
		{
			y=(tx-x1)/separation;
			if ((y>=0) && (y<noptions))
				x=y;
		}
	}
	while (x==-1);
	return(x);
}

/* -------------------------- Fa un menu vertical ------------------------- */
void pascal cadena (unsigned int x1, unsigned int y1, char *text, unsigned int max)
{
	char tmp[80];

	text[0]=max;
	sprintf(tmp, "[Introduir]. Introdueix la dada requerida (max %d carcters).", max);
	estat(tmp);
	directvideo=0;
	memset(&text[2], 0, max+1);
	memset(&text[2], 32, max);
	gotoxy(x1>>3, y1>>4);
	cputs(&text[2]);
	gotoxy(x1>>3, y1>>4);
	cgets(text);
	directvideo=1;
	strcpy(text, &text[2]);
}

/* -------------------------- Fa un menu vertical ------------------------- */
void pascal numero (unsigned int x, unsigned int y, int *n, int inc, int min, int max)
{
	register unsigned int tecla;
	char tmp[80];

	sprintf(tmp, "[Introduir]. Utilitza els cursors per variar el nmero (%d-%d).", min, max);
	estat(tmp);
	*n=min;
	do
	{
		escriure(x, y, 7, 0, "%8d", *n);
		tecla=bioskey(0);
		if (tecla==0x4800)
			(*n)+=inc;
		else if (tecla==0x5000)
			(*n)-=inc;
		else if (tecla==0x4900)
			(*n)+=10*inc;
		else if (tecla==0x5100)
			(*n)-=10*inc;
		else if (tecla==0x4700)
			(*n)=min;
		else if (tecla==0x4F00)
			(*n)=max;
		if ((*n)<min)
			(*n)=min;
		else if ((*n)>max)
			(*n)=max;
	}
	while (tecla!=0x1C0D);
}

/* ------------------- Actualitza la posici del cursor ------------------- */
void pascal cursor (int *x, int *y)
{
	register unsigned int tecla;
	unsigned int b;

	mostrarrata();
	do
	{
		do
		{
			llegirrata(x, y, &b);
			if (b&1)
				tecla=0x1C0D;
			else if (b&2)
				tecla=0x011B;
			else
				tecla=bioskey(1);
		}
		while (!tecla);
		if (b&1)
			tecla=0x1C0D;
		else if (b&2)
				tecla=0x011B;
		else
			tecla=bioskey(0);
		if (tecla==0x4800)
			(*y)--;
		else if (tecla==0x5000)
			(*y)++;
		else if (tecla==0x4B00)
			(*x)--;
		else if (tecla==0x4D00)
			(*x)++;
		if ((*x)<0)
			*x=0;
		else if ((*x)>639)
			*x=639;
		if ((*y)<0)
			*y=0;
		else if ((*y)>479)
			*y=479;
		guardarrata(*x, *y, 0);
		escriure(520, 471, 0, 7, "(%03d, %03d)", *x, *y);

	}
	while ((tecla!=0x1C0D) && (tecla!=0x011B));
	if (tecla==0x011B)
	{
		*x=-1;
		*y=-1;
	}
	ocultarrata();
}

/* ---------------------- Escriu un text a pantalla ----------------------- */
void escriure (unsigned int x, unsigned int y, unsigned int c1, unsigned int c2, char *buf, ...)
{
	 va_list argptr;
	 char aux[256];

	 va_start(argptr, buf);
	 vsprintf(aux, buf, argptr);
	 va_end(argptr);

	 setcolor(c1);
	 setfillstyle(SOLID_FILL, c2);
	 bar(x, y, x+(strlen(aux)<<3), y+8);
	 outtextxy(x, y, aux);
}

/* ------------------- Mostra la ventana d'informaci --------------------- */
void pascal avis (char *text)
{
	int k;
	char *oldb;

	oldb=malloc(imagesize(50, 210, 589, 270 ));
	if (oldb==0)
		sortir(3);
	getimage(50, 210, 589, 270, oldb);
	caixa(50, 210, 589, 270, "Avis");
	settextjustify(CENTER_TEXT, TOP_TEXT);
	setcolor(0);
	outtextxy(320, 230, "ATENCIO!");
	outtextxy(320, 250, text);
	settextjustify(LEFT_TEXT, TOP_TEXT);
	cursor(&k, &k);
	putimage(50, 210, oldb, COPY_PUT);
	free(oldb);
}

/* --------------------- Mostra la ventana del sobre ---------------------- */
void pascal sobre (void)
{
	int k;
	char *oldb;

	oldb=malloc(imagesize(200, 100, 479, 300));
	if (oldb==0)
		sortir(3);
	getimage(200, 100, 479, 300, oldb);
	caixa(200, 100, 479, 300, "Sobre el programa");
	settextjustify(CENTER_TEXT, TOP_TEXT);
	setcolor(0);
	outtextxy(339, 135, "Prctica de GEOC I v1.00");
	outtextxy(339, 155, "-");
	outtextxy(339, 175, "Aquest programari s");
	outtextxy(339, 185, "realitzat per:");
	outtextxy(339, 205, "Bernardino Casas Fernndez");
	outtextxy(339, 215, "Javier Gutirrez Chamorro");
	outtextxy(339, 235, "");
	outtextxy(339, 255, "(c) Copyright 1997-1998.");
	outtextxy(339, 265, "Tots els drets reservats");
	settextjustify(LEFT_TEXT, TOP_TEXT);
	estat("[Sobre]. Pitja qualsevol tecla o bot.");
	delay(250);
	cursor(&k, &k);
	putimage(200, 100, oldb, COPY_PUT);
	free(oldb);
}

/* ------------------- Mostra la ventana d'informaci --------------------- */
void pascal info (void)
{
	int k;
	char *oldb;
	char tmp[80];

	oldb=malloc(imagesize(50, 180, 589, 320 ));
	if (oldb==0)
		sortir(3);
	getimage(50, 180, 589, 320, oldb);
	caixa(50, 180, 589, 320, "Informaci");
	settextjustify(CENTER_TEXT, TOP_TEXT);
	setcolor(0);
	sprintf(tmp, "Memoria base total: %u Koctets", biosmemory());
	outtextxy(320, 200, tmp);
	sprintf(tmp, "Memoria base lliure: %u Koctets", coreleft()>>10);
	outtextxy(320, 210, tmp);
	sprintf(tmp, "Mode de video: VGA 640x480 16 colors");
	outtextxy(320, 230, tmp);
	if (_8087==0)
		sprintf(tmp, "Coprocessador matemtic: No instal.lat");
	else
		sprintf(tmp, "Coprocessador matemtic: 80%u87 instal.lat", _8087);
	outtextxy(320, 250, tmp);
	sprintf(tmp, "Ratol: %u botons instal.lat", esrata());
	outtextxy(320, 270, tmp);
	sprintf(tmp, "DOS versi: %u.%02u", _osmajor, _osminor);
	outtextxy(320, 290, tmp);
	settextjustify(LEFT_TEXT, TOP_TEXT);
	delay(250);
	cursor(&k, &k);
	putimage(50, 180, oldb, COPY_PUT);
	free(oldb);
}


/* ---------------------- Mostra el men principal ------------------------ */
void pascal principal (void)
{
	register int i;
	int x, y;
	char *oldb;
	char tmp[81];
	char menu[][41]={
										"        Inserir...       ",
										"        Esborrar...      ",
										"      Transformar...     ",
										"Carregar vectorial (.VEC)",
										"Guardar vectorial (.VEC) ",
										"Carregar pantalla (.RAW) ",
										" Guardar pantalla (.RAW) ",
										"    Refrescar pantalla   ",
										"          Sortir         "
									};
	while(1)
	{
		do
		{
			estat("[Principal]. Escape o bot dret per veure el menu");
			delay(250);
			do
			{
				cursor(&x, &y);
				if (x!=-1)
				{
					sprintf(tmp, "%u de %u usat (%u%% lliure)", index, MAX_VECTOR, 100-(index*100/MAX_VECTOR));
					avis(tmp);
				}
			}
			while (x!=-1);
			estat("[Principal]. Marca la comanda desitjada");
			oldb=malloc(imagesize(190, 100, 449, 379));
			if (oldb==0)
				sortir(3);
			getimage(190, 100, 449, 379, oldb);
			caixa(190, 100, 449, 379, "Menu Principal");
			i=vmenu(210, 120, menu, 9, 15);
			putimage(190, 100, oldb, COPY_PUT);
			free(oldb);
			if (i==0)
				inserir();
			else if (i==1)
				esborrartot();
			else if (i==2)
				transformar();
			else if (i==3)
				carregarvec();
			else if (i==4)
				grabarvec();
			else if (i==5)
				carregarraw();
			else if (i==6)
				grabarraw();
			else if (i==7)
				refrescar();
		}
		while (i!=8);
		sortir(0);
	}
}

/* ---------------------- Mostra el men principal ------------------------ */
void pascal inserir (void)
{
	register int i;
	char *oldb;
	char menu[][41]={
										"          Linia          ",
										"           Arc           ",
										"      Circumferencia     ",
										"      Polgon Regular    ",
										"     Polgon Irregular   ",
										"         El.lipse        ",
										"         Rectangle       ",
										"        Cancel.lar       ",

									};

	estat("[Inserir]. Marca la comanda desitjada");
	delay(250);
	oldb=malloc(imagesize(190, 100, 449, 379));
	if (oldb==0)
		sortir(3);
	getimage(190, 100, 449, 379, oldb);
	caixa(190, 100, 449, 379, "Menu Inserir");
	i=vmenu(210, 120, menu, 8, 15);
	putimage(190, 100, oldb, COPY_PUT);
	free(oldb);
	if (i==0)
		ferlinia();
	else if (i==1)
		ferarc();
	else if (i==2)
		fercircumferencia();
	else if (i==3)
		ferpoligonreg();
	else if (i==5)
		ferelipse();
	else if (i==6)
		ferrectangle();
}


/* ---------------------- Carrrega una imatge .RAW ------------------------ */
void pascal carregarraw (void)
{
	register unsigned int x, y;
	FILE *f;
	char *oldb;
	char nom[81];
	char tmp[640];

	oldb=malloc(imagesize(180, 180, 459, 229));
	if (oldb==0)
		sortir(3);
	getimage(180, 180, 459, 229, oldb);
	caixa(180, 180, 459, 229, "Carregar RAW");
	escriure(200, 200, 0, 15, "Nom del fitxer a carregar?");
	cadena(200, 230, nom, 30);
	strupr(nom);
	if (strchr(nom, '.')==0)
		strcat(nom, ".RAW");
	directvideo=0;
	gotoxy(200/8, 230/16);
	cputs(nom);
	directvideo=1;
	putimage(180, 180, oldb, COPY_PUT);
	free(oldb);
	f=fopen(nom, "rb");
	if (f==0)
	{
		avis("Impossible obrir fitxer");
		return;
	}
	for (y=0; y<13; y++)
	{
		fread(tmp, 1, 640, f);
	}
	for (y=13; y<=471; y++)
	{
		if (y%48==0)
		{
			sprintf(tmp, "[Carregant]. %s (%3u%%)...", nom, y*100/480);
			estat(tmp);
		}
		fread(tmp, 1, 640, f);
		for (x=0; x<640; x++)
			putpixel(x, y, tmp[x]);
	}
	for (y=472; y<480; y++)
	{
		fread(tmp, 1, 640, f);
	}
	fclose(f);
}

/* ------------------------ Guarda una imatge .RAW ------------------------ */
void pascal grabarraw (void)
{
	register unsigned int x, y;
	FILE *f;
	char *oldb;
	char nom[81];
	char tmp[640];

	oldb=malloc(imagesize(180, 180, 459, 229));
	if (oldb==0)
		sortir(3);
	getimage(180, 180, 459, 229, oldb);
	caixa(180, 180, 459, 229, "Grabar RAW");
	escriure(200, 200, 0, 15, "Nom del fitxer a grabar?");
	cadena(200, 230, nom, 30);
	strupr(nom);
	if (strchr(nom, '.')==0)
		strcat(nom, ".RAW");
	directvideo=0;
	gotoxy(200/8, 230/16);
	cputs(nom);
	directvideo=1;
	putimage(180, 180, oldb, COPY_PUT);
	free(oldb);
	f=fopen(nom, "wb");
	if (f==0)
	{
		avis("Impossible crear fitxer");
		return;
	}
	memset(tmp, 7, 640);
	for(y=0; y<13; y++)
	{
		fwrite(tmp, 1, 640, f);
	}
	for (y=13; y<=471; y++)
	{
		if (y%48==0)
		{
			sprintf(tmp, "[Guardant]. %s (%3u%%)...", nom, y*100/480);
			estat(tmp);
		}
		for (x=0; x<640; x++)
			tmp[x]=getpixel(x, y);
		fwrite(tmp, 1, 640, f);
	}
	memset(tmp, 7, 640);
	for(y=472; y<480; y++)
	{
		fwrite(tmp, 1, 640, f);
	}
	fclose(f);
}

/* ---------------------- Carrrega una imatge .VEC ------------------------ */
void pascal carregarvec (void)
{
	FILE *f;
	char *oldb;
	char vechea[32];
	char nom[81];
	char tmp[640];

	oldb=malloc(imagesize(180, 180, 459, 229));
	if (oldb==0)
		sortir(3);
	getimage(180, 180, 459, 229, oldb);
	caixa(180, 180, 459, 229, "Carregar VEC");
	escriure(200, 200, 0, 15, "Nom del fitxer a carregar?");
	cadena(200, 230, nom, 30);
	strupr(nom);
	if (strchr(nom, '.')==0)
		strcat(nom, ".VEC");
	directvideo=0;
	gotoxy(200/8, 230/16);
	cputs(nom);
	directvideo=1;
	putimage(180, 180, oldb, COPY_PUT);
	free(oldb);
	esborrartot();
	f=fopen(nom, "rb");
	if (f==0)
	{
		avis("Impossible obrir fitxer");
		return;
	}
	sprintf(tmp, "[Carregant]. %s (%3u%%)...", nom, 0);
	estat(tmp);
	fread(vechea, 1, 32, f);
	if (strcmp(vechea, "Fitxer VECtor de GEOC1")!=0)
	{
		avis("No s un fitxer .VEC");
		fclose(f);
		return;
	}
	fread(&vector, 1, filelength(fileno(f)), f);
	sprintf(tmp, "[Carregant]. %s (%3u%%)...", 100);
	estat(tmp);
	index=filelength(fileno(f))/sizeof(struct svector);
	fclose(f);
	refrescar();
}

/* ------------------------ Guarda una imatge .VEC ------------------------ */
void pascal grabarvec (void)
{
	FILE *f;
	char *oldb;
	char nom[81];
	char tmp[640];

	oldb=malloc(imagesize(180, 180, 459, 229));
	if (oldb==0)
		sortir(3);
	getimage(180, 180, 459, 229, oldb);
	caixa(180, 180, 459, 229, "Grabar VEC");
	escriure(200, 200, 0, 15, "Nom del fitxer a grabar?");
	cadena(200, 230, nom, 30);
	strupr(nom);
	if (strchr(nom, '.')==0)
		strcat(nom, ".VEC");
	directvideo=0;
	gotoxy(200/8, 230/16);
	cputs(nom);
	directvideo=1;
	putimage(180, 180, oldb, COPY_PUT);
	free(oldb);
	f=fopen(nom, "wb");
	if (f==0)
	{
		avis("Impossible crear fitxer");
		return;
	}
	sprintf(tmp, "[Guardant]. %s (%3u%%)...", 0);
	estat(tmp);
	fwrite("Fitxer VECtor de GEOC1", 1, 32, f);
	fwrite(&vector, sizeof(struct svector), index, f);
	sprintf(tmp, "[Guardant]. %s (%3u%%)...", 100);
	estat(tmp);
	fclose(f);
}


/* -------------------------- Refresca la pantalla ------------------------ */
void pascal refrescar (void)
{
	register unsigned int i;
	int r;
	char tmp[80];

	fons();
	for (i=0; i<=index; i++)
	{
		setcolor(0);
		if (vector[i].afes==1)
		{
			sprintf(tmp, "Dibuixant %s", vector[i].sim);
			estat(tmp);
			if (vector[i].id==ID_ARC)
			{
				setviewport(0, 13, 639, 471, 1);
				arc(vector[i].x1, vector[i].y1, vector[i].a1, vector[i].a2, max(abs(vector[i].y2-vector[i].y1), abs(vector[i].x2-vector[i].x1)));
				setviewport(0, 0, 639, 439, 0);
			}
			else if (vector[i].id==ID_CIRCUMFERENCIA)
			{
				setviewport(0, 13, 639, 471, 1);
				circle(vector[i].x1, vector[i].y1, sqrt((pow((vector[i].y2-vector[i].y1), 2))+(pow((vector[i].x2-vector[i].x1), 2))));
				setviewport(0, 0, 639, 439, 0);
			}
			else if (vector[i].id==ID_ELIPSE)
			{
				setviewport(0, 13, 639, 471, 1);
				ellipse(vector[i].x1, vector[i].y1, 0, 360, abs(vector[i].x2-vector[i].x1), abs(vector[i].y2-vector[i].y1));
				setviewport(0, 0, 639, 439, 0);
			}
			else if (vector[i].id==ID_LINIA)
			{
				setviewport(0, 13, 639, 471, 1);
				line (vector[i].x1, vector[i].y1, vector[i].x2, vector[i].y2);
				setviewport(0, 0, 639, 439, 0);
			}
			else if (vector[i].id==ID_RECTANGLE)
			{
				setviewport(0, 13, 639, 471, 1);
				rectangle (vector[i].x1, vector[i].y1, vector[i].x2, vector[i].y2);
				setviewport(0, 0, 639, 439, 0);
			}
		}
	}
}

/* -------------------------- Refresca la pantalla ------------------------ */
void pascal ferarc (void)
{
	int x1, y1, x2, y2, s1, s2, r;

	estat("[Arc]. Selecciona amb cursors el centre, i ENTER per confirmar");
	delay(250);
	cursor(&x1, &y1);
	putpixel(x1, y1, 12);
	delay(250);
	estat("[Arc]. Selecciona amb cursors el radi, i ENTER per confirmar");
	cursor(&x2, &y2);
	putpixel(x2, y2, 12);
	estat("[Arc]. Entra el primer angle...");
	numero(550, 470, &s1, 1, 1, 360);
	estat("[Arc]. Entra el segon angle...");
	numero(550, 470, &s2, 1, 1, 360);
	setcolor(0);
	r=max(abs(y2-y1), abs(x2-x1));
	setviewport(0, 13, 639, 471, 1);
	arc(x1, y1, min(s1, s2), max(s1, s2), r);
	setviewport(0, 0, 639, 439, 0);
	vector[index].id=ID_ARC;
	vector[index].x1=x1;
	vector[index].y1=y1;
	vector[index].x2=x2;
	vector[index].y2=y2;
	vector[index].a1=s1;
	vector[index].a2=s2;
	sprintf(vector[index].sim, "ARC %u", index);
	vector[index].next=-1;
	vector[index].afes=1;
	index++;
}

/* -------------------------- Refresca la pantalla ------------------------ */
void pascal fercircumferencia (void)
{
	int x1, y1, x2, y2, r;

	estat("[Circumferencia]. Selecciona amb cursors el centre, i ENTER per confirmar");
	delay(250);
	cursor(&x1, &y1);
	if (x1==-1)
		return;
	putpixel(x1, y1, 12);
	estat("[Circumferencia]. Selecciona amb cursors el radi, i ENTER per confirmar");
	delay(250);
	cursor(&x2, &y2);
	if (x2==-1)
		return;
	putpixel(x2, y2, 12);
	setcolor(0);
	r=sqrt((pow((y2-y1), 2))+(pow((x2-x1), 2)));
	setviewport(0, 13, 639, 471, 1);
	circle(x1, y1, r);
	setviewport(0, 0, 639, 439, 0);
	vector[index].id=ID_CIRCUMFERENCIA;
	vector[index].x1=x1;
	vector[index].y1=y1;
	vector[index].x2=x2;
	vector[index].y2=y2;
	vector[index].a1=-1;
	vector[index].a2=-1;
	sprintf(vector[index].sim, "CIRCUMFERENCIA %u", index);
	vector[index].next=-1;
	vector[index].afes=1;
	index++;
}

/* -------------------------- Refresca la pantalla ------------------------ */
void pascal ferelipse (void)
{
	int x1, y1, x2, y2, rx, ry;

	estat("[El.lipse]. Selecciona amb cursors el centre, i ENTER per confirmar");
	delay(250);
	cursor(&x1, &y1);
	if (x1==-1)
		return;
	putpixel(x1, y1, 12);
	estat("[El.lipse]. Selecciona amb cursors el radi, i ENTER per confirmar");
	delay(250);
	cursor(&x2, &y2);
	if (x2==-1)
		return;
	putpixel(x2, y2, 12);
	setcolor(0);
	rx=abs(x2-x1);
	ry=abs(y2-y1);
	setviewport(0, 13, 639, 471, 1);
	ellipse(x1, y1, 0, 360, rx, ry);
	setviewport(0, 0, 639, 439, 0);
	vector[index].id=ID_ELIPSE;
	vector[index].x1=x1;
	vector[index].y1=y1;
	vector[index].x2=x2;
	vector[index].y2=y2;
	vector[index].a1=-1;
	vector[index].a2=-1;
	sprintf(vector[index].sim, "EL.LIPSE %u", index);
	vector[index].next=-1;
	vector[index].afes=1;
	index++;
}

/* -------------------------- Refresca la pantalla ------------------------ */
void pascal ferlinia (void)
{
	int x1, y1, x2, y2;

	estat("[Linea]. Selecciona amb cursors el primer punt, i ENTER per confirmar");
	delay(250);
	cursor(&x1, &y1);
	if (x1==-1)
		return;
	putpixel(x1, y1, 12);
	estat("[Linea]. Selecciona amb cursors el segon punt, i ENTER per confirmar");
	delay(250);
	cursor(&x2, &y2);
	if (x2==-1)
		return;
	putpixel(x2, y2, 12);
	setcolor(0);
	setviewport(0, 13, 639, 471, 1);
	line (x1, y1, x2, y2);
	setviewport(0, 0, 639, 439, 0);
	vector[index].id=ID_LINIA;
	vector[index].x1=x1;
	vector[index].y1=y1;
	vector[index].x2=x2;
	vector[index].y2=y2;
	vector[index].a1=-1;
	vector[index].a2=-1;
	sprintf(vector[index].sim, "LINIA %u", index);
	vector[index].next=-1;
	vector[index].afes=1;
	index++;
}

/* -------------------------- Refresca la pantalla ------------------------ */
void pascal ferpoligonreg (void)
{
	int i;
	int x1, y1, x2, y2, r, n, tmpx, tmpy;
	float angle;
	int poligon[40];

	estat("[PoligonReg]. Selecciona amb cursors el vertex, i ENTER per confirmar");
	cursor(&x1, &y1);
	putpixel(x1, y1, 12);
	estat("[PoligonReg]. Selecciona amb cursors el radi, i ENTER per confirmar");
	cursor(&x2, &y2);
	putpixel(x2, y2, 12);

	estat("[PoligonReg]. Entra el nmero de costats...");
	//numero(&n, 3, 20);

	r=max(abs(y2-y1), abs(x2-x1));
	angle=(360/n)*PI/180;
	tmpx=x1;
	tmpy=y1;
	for (i=1; i<=n; i++)
	{
		poligon[i*2]=(tmpx-x1)*cos(angle)+(tmpy-y1)*(-sin(angle));
		poligon[i*2+1]=(tmpy-y1)*sin(angle)+(tmpx-x1)*cos(angle);
		tmpx=poligon[i*2];
		tmpy=poligon[i*2+1];
	}
	setcolor(0);
	setviewport(0, 13, 639, 471, 1);
	drawpoly(n, poligon);
	setviewport(0, 0, 639, 439, 0);
	vector[index].id=ID_POLIGONREG;
	vector[index].x1=x1;
	vector[index].y1=y1;
	vector[index].x2=x2;
	vector[index].y2=y2;
	vector[index].a1=.1;
	vector[index].a2=-1;
	sprintf(vector[index].sim, "POLIGONREG %u", index);
	vector[index].next=-1;
	vector[index].afes=1;
	index++;
}

/* -------------------------- Refresca la pantalla ------------------------ */
void pascal ferpoligonireg (void)
{
}

/* -------------------------- Refresca la pantalla ------------------------ */
void pascal ferrectangle (void)
{
	int x1, y1, x2, y2;

	estat("[Rectangle]. Selecciona amb cursors el primer punt, pitja ENTER per confirmar");
	delay(250);
	cursor(&x1, &y1);
	if (x1==-1)
		return;
	putpixel(x1, y1, 12);
	estat("[Rectangle]. Selecciona amb cursors el segon punt, i ENTER per confirmar");
	delay(250);
	cursor(&x2, &y2);
	if (x2==-1)
		return;
	putpixel(x2, y2, 12);
	setcolor(0);
	setviewport(0, 13, 639, 471, 1);
	rectangle (x1, y1, x2, y2);
	setviewport(0, 0, 639, 439, 0);
	vector[index].id=ID_RECTANGLE;
	vector[index].x1=x1;
	vector[index].y1=y1;
	vector[index].x2=x2;
	vector[index].y2=y2;
	vector[index].a1=-1;
	vector[index].a2=-1;
	sprintf(vector[index].sim, "RECTANGLE %u", index);
	vector[index].next=-1;
	vector[index].afes=1;
	index++;
}

/* -------------------------- Refresca la pantalla ------------------------ */
void pascal esborrartot (void)
{
	register unsigned int i;

	memset(vector, 0, sizeof(vector));
	for (i=0; i<MAX_VECTOR; i++)
	{
		vector[i].id=ID_BUIT;
		vector[i].x1=-1;
		vector[i].y1=-1;
		vector[i].x2=-1;
		vector[i].y2=-1;
		vector[i].a1=-1;
		vector[i].a2=-1;
		sprintf(vector[i].sim, "BUIT %u", i);
		vector[i].next=-1;
		vector[i].afes=-1;
	}
	index=0;
	refrescar();
}

/* ----------------------- Retorna la figura cliqueada -------------------- */
int pascal triarfigura (void)
{
	register int i, j;
	char *oldb;
	char tmp[81];
	char menu[13][41];

	oldb=malloc(imagesize(190, 100, 449, 379));
	if (oldb==0)
		sortir(3);
	getimage(190, 100, 449, 379, oldb);
	caixa(190, 100, 449, 379, "Triar primitiva");
	estat("[Triar]. Marca la primitiva desitjada");
	strcpy(menu[10], "Anterior");
	strcpy(menu[11], "Segent");
	strcpy(menu[12], "Cancel.lar");
	j=0;
	do
	{
		for (i=0; i!=10; i++)
		{
			memset(tmp, 0, 27);
			memset(tmp, 32, 26);
			memcpy(tmp, vector[i+j].sim, strlen(vector[i+j].sim));
			strcpy(menu[i], tmp);
		}
		i=vmenu(210, 120, menu, 13, 15);
		if (i==10)
			j-=10;
		else if (i==11)
			j+=10;
		if (j<0)
			j=0;
		if (j>MAX_VECTOR-1)
			j=MAX_VECTOR-1;
	}
	while ((i==10) || (i==11));
	putimage(190, 100, oldb, COPY_PUT);
	free(oldb);
	if (i==12)
		return(-1);
	else
		return(j+i);
}

/* ----------------------- Retorna la figura cliqueada -------------------- */
void pascal transformar (void)
{
	int i, j;
	char *oldb;
	char menu[][41]={
										"         Copiar          ",
										"        Traslladar       ",
										"          Girar          ",
										"         Escalar         ",
										"       Cancel.lar        ",
									};

	j=triarfigura();
	if (j<0)
		return;
	estat("[Transformar] Marca la comanda desitjada");
	oldb=malloc(imagesize(190, 100, 449, 379));
	if (oldb==0)
		sortir(3);
	getimage(190, 100, 449, 379, oldb);
	caixa(190, 100, 449, 379, "Menu Transformar");
	i=vmenu(210, 120, menu, 5, 15);
	putimage(190, 100, oldb, COPY_PUT);
	free(oldb);
}

