#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <bios.h>
#include <conio.h>
#include <time.h>
#include <dir.h>
#include "comlib.h"

/* --------------------- Cambia la paleta por defecto --------------------- */
void _fastcall setpal (unsigned char e)
{
	register unsigned int i;
	unsigned char *auxpal;
	union REGS r;
	unsigned char defpal[]={ 	0x00, 0x00, 0x00, /* 00 */
														0x00, 0x00, 0x2A,	/* 01 */
														0x00, 0x2A, 0x00, /* 02 */
														0x00, 0x2A, 0x2A, /* 03 */
														0x2A, 0x00, 0x00, /* 04 */
														0x2A, 0x00, 0x2A, /* 05 */
														0x2A, 0x2A, 0x00, /* 06 */
														0x2A, 0x2A, 0x2A, /* 07 */
														0x00, 0x00, 0x15, /* 08 */
														0x00, 0x00, 0x3F,	/* 09 */
														0x00, 0x2A, 0x15, /* 10 */
														0x00, 0x2A, 0x3F, /* 11 */
														0x2A, 0x00, 0x15, /* 12 */
														0x2A, 0x00, 0x3F, /* 13 */
														0x2A, 0x2A, 0x15, /* 14 */
														0x2A, 0x2A, 0x3F};/* 15 */
	unsigned char newpal[]={ 	0x00, 0x00, 0x00, /* 00 */
														0x00, 0x00, 0x24,	/* 01 */
														0x00, 0x24, 0x04, /* 02 */
														0x00, 0x22, 0x28, /* 03 */
														0x24, 0x00, 0x00, /* 04 */
														0x28, 0x08, 0x2A, /* 05 */
														0x30, 0x30, 0x08, /* 06 */
														0x2B, 0x2B, 0x2B, /* 07 */
														0x00, 0x00, 0x1D, /* 08 */
														0x04, 0x08, 0x3C,	/* 09 */
														0x00, 0x28, 0x0E, /* 10 */
														0x00, 0x1F, 0x3F, /* 11 */
														0x28, 0x04, 0x10, /* 12 */
														0x2C, 0x08, 0x3F, /* 13 */
														0x30, 0x2A, 0x10, /* 14 */
														0x30, 0x30, 0x3F};/* 15 */
	/* Permitir parpadeo */
	r.x.ax=0x1003;
	r.h.bl=1;
	int86(0x10, &r, &r);
	if (e==0)
		auxpal=defpal;
	else
		auxpal=newpal;
	for (i=0; i<=15; i++)
  {
		r.x.ax=0x1010;
		r.x.bx=i;
    r.h.dh=*auxpal; /* Red */
		auxpal++;
		r.h.ch=*auxpal; /* Green */
		auxpal++;
		r.h.cl=*auxpal; /* Blue */
		auxpal++;
		int86(0x10, &r, &r);
	}
}

/* ----------------- Borra la pantalla con efecto de empuje ---------------- */
unsigned int _fastcall ckey (void)
{
  register unsigned int tecla;
  union REGS r;

  /* Mouse show */
  r.x.ax=1;
  int86(0x33, &r, &r);
  do
  {
    watch();
    tecla=bioskey(1);
  }
  while (tecla==0);
  tecla=bioskey(0);
  /* Mouse hidde */
  r.x.ax=2;
  int86(0x33, &r, &r);
  return(tecla);
}

/* ----------------- Borra la pantalla con efecto de empuje ---------------- */
void _fastcall empuja (void)
{
	register unsigned char i;
  union REGS r;

	/* Borra la pantalla con efecto de empuje */
	for (i=0; i!=13; i++)
	{
		/* Cuadro 1 */
    r.x.ax=0x0701;   /* 6 arriba, 7 abajo */ /* Linea a desplazar */
    r.h.bh=0x07;     /* Atributo */
    r.x.cx=0x0000;   /* Y orgen */ /* X orgen */
    r.x.dx=0x0C0D;   /* Y destino */ /* X destino */
    int86(0x10, &r, &r);
		/* Cuadro 2 */
		r.x.ax=0x0601;   /* 6 arriba, 7 abajo */ /* Linea a desplazar */
		r.h.bh=7;        /* Atributo */
		r.x.cx=0x000E;   /* Y orgen */ /* X orgen */
		r.x.dx=0x0C3F;   /* Y destino */ /* X destino */
		int86(0x10, &r, &r);
		/* Cuadro 3 */
    r.x.ax=0x0701;   /* 6 arriba, 7 abajo */ /* Linea a desplazar */
    r.h.bh=7;        /* Atributo */
    r.x.cx=0x0040;   /* Y orgen */ /* X orgen */
    r.x.dx=0x0C4F;   /* Y destino */ /* X destino */
		int86(0x10, &r, &r);
		/* Cuadro 4 */
		r.x.ax=0x0601;   /* 6 arriba, 7 abajo */ /* Linea a desplazar */
    r.h.bh=7;        /* Atributo */
    r.x.cx=0x0D00;   /* Y orgen */ /* X orgen */
    r.x.dx=0x180D;   /* Y destino */ /* X destino */
		int86(0x10, &r, &r);
		/* Cuadro 5 */
    r.x.ax=0x0701;   /* 6 arriba, 7 abajo */ /* Linea a desplazar */
    r.h.bh=7;        /* Atributo */
    r.x.cx=0x0D0E;   /* Y orgen */ /* X orgen */
    r.x.dx=0x183F;   /* Y destino */ /* X destino */
    int86(0x10, &r, &r);
		/* Cuadro 6 */
    r.x.ax=0x0601;   /* 6 arriba, 7 abajo */ /* Linea a desplazar */
		r.h.bh=7;        /* Atributo */
    r.x.cx=0x0D40;   /* Y orgen */ /* X orgen */
    r.x.dx=0x184F;   /* Y destino */ /* X destino */
    int86(0x10, &r, &r);
    delay (50);
	}
}


/* ------------ Escribe en pantalla el estado de los bloqueos ------------- */
void _fastcall watch (void)
{
	unsigned char oldx, oldy;
	struct time t;

  oldx=wherex();
	oldy=wherey();
	gettime(&t);
	gotoxy(63, 25);
	textattr(7*16+0);
	cprintf("            %2u", t.ti_hour);
	textattr(7*16+0+128);
	putch(':');
	textattr(7*16+0);
	cprintf("%02u", t.ti_min);
  gotoxy(oldx, oldy);
}

/* ------------ Escribe en pantalla el estado de los bloqueos ------------- */
void _fastcall blocks (void)
{
  register unsigned char fun;
  unsigned char oldx, oldy;

  oldx=wherex();
  oldy=wherey();
	fun=bioskey(2);		/* 0040:0017 */
  textattr(7*16+0);
	gotoxy(64, 25);
	if (fun & 128)
    cputs("INS ");
  else
    cputs("    ");
	if (fun & 64)
    cputs("CAP ");
  else
    cputs("    ");
	if (fun & 32)
    cputs("NUM ");
  else
    cputs("    ");
	if (fun & 16)
    cputs("SCR ");
  else
    cputs("    ");
  gotoxy(oldx, oldy);
}

/* ----------------------- Escribe un texto centrado ---------------------- */
void pascal cputsc (unsigned char x1, unsigned char x2, unsigned char y, char *str)
{
	register unsigned char x;

	x=(((x2-x1+1)>>1)-(strlen(str)>>1)+x1);
	gotoxy(x, y);
	cputs(str);
}

/* -------------------- Consigue una cadena por teclado ------------------- */
void pascal getstr (unsigned char x, unsigned char y, unsigned char atr, char *str, char len)
{
	register char i;
	register unsigned int tec;
	char aux[80];

	textattr(7*16+0);
	gotoxy(1, 25);
	cputs("Introduce una cadena vlida                                         ");
	_setcursortype(_SOLIDCURSOR);
	memset(aux, 0, 80);
	memset(aux, 32, len+1);
	textattr(atr);
	gotoxy(x, y);
	cputs(aux);
	strcpy(aux, str);
	i=strlen(aux);
	str[i]=0;
	gotoxy(x, y);
	cputs(aux);
	do
	{
		blocks();
		tec=bioskey(0);
    textattr(atr);
		if (tec==0x0E08)
		{
			if (i>0)
			{
				cputs("\b \b");
				i--;
				aux[i]=0;
			}
		}
		else if (tec==0x011B)
		{
		}
		else if (tec==0x1C0D)
		{
			strcpy(str, aux);
			i=strlen(aux)+1;
		}
		else if (tec==0x4B00)
		{
			if (i>0)
			{
				gotoxy(wherex()-1, wherey());
				i--;
			}
		}
		else if (tec==0x4D00)
		{
			if (i<len)
			{
				gotoxy(wherex()+1, wherey());
				i++;
			}
		}
		else
		{
			if (i<len)
			{
				putch((char) tec);
				aux[i]=(char) tec;
				i++;
				aux[i]=0;
			}
		}
	}
	while ((tec!=0x1C0D) && (tec!=0x011B));
	if (tec!=0x011B)
		str[i]=0;
  _setcursortype(_NOCURSOR);
}

/* ------------------- Consigue un password por teclado ------------------- */
void pascal getpw (unsigned char x, unsigned char y, unsigned char atr, char *pass, char len)
{
	register char i;
	register unsigned int tec;

	textattr(7*16+0);
  gotoxy(1, 25);
	cputs("Introduzca password                                                 ");
	_setcursortype(_NOCURSOR);
	memset(pass, 0, len+2);
	memset(pass, 32, len+1);
	textattr(atr);
	gotoxy(x, y);
	cputs(pass);
	pass[0]=0;
	i=0;
	gotoxy(x, y);
	do
	{
		blocks();
		tec=bioskey(0);
    textattr(atr);
		if (tec==0x0E08)
		{
			if (i>0)
			{
				cputs("\b \b");
				i--;
			}
		}
		else if ((tec==0x1C0D) || (tec==0x011B))
		{
		}
		else
		{
			if (i<len)
			{
				putch('*');
				pass[i]=(char) tec;
				i++;
			}
		}
	}
	while ((tec!=0x1C0D) && (tec!=0x011B));
	pass[i]=0;
	_setcursortype(_NOCURSOR);
}

/* ------------------------ Hace un men de botones ----------------------- */
unsigned char buttons (unsigned char x1, unsigned char y1, unsigned char atr0, unsigned char atr1, char menu[][11], char desc[][71], unsigned char noptions, unsigned char separation)
{
  register char x;
	register unsigned int tecla;
	char y;
	union REGS r;

	textattr(atr0);
  for (x=0; x!=noptions; x++)
  {
    gotoxy(x1+x*separation, y1);
		cputs(menu[x]);
  }
  textattr(2*16+15);
	gotoxy(x1, y1);
	cputs(menu[0]);
  textattr(7*16+0);
  gotoxy(1, 25);
  cputs(desc[0]);
	x=0;
	do
	{
		/* Mouse show */
		r.x.ax=1;
		int86(0x33, &r, &r);
		do
		{
			watch();
			tecla=bioskey(1);
			if (tecla!=0)
				tecla=bioskey(0);
			/* Get mouse */
			r.x.ax=3;
			int86(0x33, &r, &r);
			r.x.cx=(r.x.cx>>3)+1;
			r.x.dx=(r.x.dx>>3)+1;
			/* Left button */
			if ((r.x.bx==1) && (r.x.dx==y1))
			{
				y=(r.x.cx-x1)/separation;
				if ((y>=0) && (y<noptions))
				{
					tecla=0x1C0D;
					x=y;
				}
			}
			/* Right button */
			else if (r.x.bx==2)
				tecla=0x3B00;
		}
		while ((tecla!=0x4B00) && (tecla!=0x4D00) && (tecla!=0x011B) &&
					 (tecla!=0x1C0D) && (tecla!=0x3B00));
		/* Mouse hidde */
		r.x.ax=2;
		int86(0x33, &r, &r);
		textattr(atr0);
		gotoxy(x1+x*separation, y1);
		cputs(menu[x]);
		if (tecla==0x4B00)				/* Left */
			x--;
		else if (tecla==0x4D00)		/* Right */
			x++;
		if (x>noptions-1)
			x=0;
		else if (x<0)
			x=noptions-1;
		textattr(atr1);
		gotoxy(x1+x*separation, y1);
		cputs(menu[x]);
		textattr(7*16+0);
		gotoxy(1, 25);
		cputs(desc[x]);
	}
	while ((tecla!=0x1C0D) && (tecla!=0x011B) && (tecla!=0x3B00));
	if (tecla==0x011B)
		return(0);
	else if (tecla==0x3B00)
		return(255);
	else
		return(x);
}

/* ------------------------------- Hace un men --------------------------- */
unsigned char pascal menu (unsigned char x1, unsigned char y1, unsigned char atr0, unsigned char atr1, char menu[][21], char desc[][71], unsigned char noptions, unsigned char separation)
{
  register char y;
	register unsigned int tecla;
	char x, l;
	union REGS r;

	l=strlen(menu[0])-1;
	textattr(atr0);
  for (y=0; y!=noptions; y++)
  {
    gotoxy(x1, y1+y*separation);
		cputs(menu[y]);
  }
  textattr(atr1);
	gotoxy(x1, y1);
	cputs(menu[0]);
  textattr(7*16+0);
  gotoxy(1, 25);
  cputs(desc[0]);
	y=0;
	do
	{
		/* Mouse show */
		r.x.ax=1;
		int86(0x33, &r, &r);
		do
		{
			watch();
			tecla=bioskey(1);
			if (tecla!=0)
				tecla=bioskey(0);
			/* Get mouse */
			r.x.ax=3;
			int86(0x33, &r, &r);
			r.x.cx=(r.x.cx>>3)+1;
			r.x.dx=(r.x.dx>>3)+1;
			/* Left button */
			if ((r.x.bx==1) && (r.x.cx>=x1) && (r.x.cx<=(x1+l)))
			{
				x=(r.x.dx-y1)/separation;
        if ((x>=0) && (x<noptions))
				{
					tecla=0x1C0D;
          y=x;
				}
			}
			/* Right button */
			else if (r.x.bx==2)
				tecla=0x3B00;
		}
		while ((tecla!=0x4800) && (tecla!=0x5000) && (tecla!=0x4700) &&
					 (tecla!=0x4F00) && (tecla!=0x011B) && (tecla!=0x1C0D) &&
					 (tecla!=0x3B00));
		/* Mouse hidde */
		r.x.ax=2;
		int86(0x33, &r, &r);
		textattr(atr0);
		gotoxy(x1, y1+y*separation);
		cputs(menu[y]);
		if (tecla==0x4800)        /* Up */
			y--;
		else if (tecla==0x5000)   /* Dw */
			y++;
		else if (tecla==0x4700)   /* Org */
			y=0;
		else if (tecla==0x4F00)   /* End */
			y=noptions-1;
		if (y>noptions-1)
			y=0;
		else if (y<0)
			y=noptions-1;
		textattr(atr1);
		gotoxy(x1, y1+y*separation);
		cputs(menu[y]);
		textattr(7*16+0);
		gotoxy(1, 25);
		cputs(desc[y]);
	}
	while ((tecla!=0x1C0D) && (tecla!=0x011B) && (tecla!=0x3B00));
	if (tecla==0x011B)
		return(0);
	else if (tecla==0x3B00)
		return(255);
	else
		return(y);
}

/* ----------------------- Hace un men de opciones ----------------------- */
unsigned char pascal option (unsigned char x1, unsigned char y1, unsigned char atr0, unsigned char atr1, char menu[][21], char desc[][71], char *sel, unsigned char noptions, unsigned char separation, unsigned char activado)
{
	register char y;
	register unsigned int tecla;
	char x;
	union REGS r;

	textattr(atr0);
	for (y=0; y!=noptions; y++)
	{
		gotoxy(x1, y1+y*separation);
		cprintf("[%c] %s", sel[y], menu[y]);
	}
	if (activado==0)
		return(0);
	textattr(atr1);
	gotoxy(x1, y1);
	cprintf("[%c] %s", sel[0], menu[0]);
	textattr(7*16+0);
	gotoxy(1, 25);
	cputs(desc[0]);
	y=0;
	do
	{
		/* Mouse show */
		r.x.ax=1;
		int86(0x33, &r, &r);
		do
		{
			watch();
			tecla=bioskey(1);
			if (tecla!=0)
				tecla=bioskey(0);
			/* Get mouse */
			r.x.ax=3;
			int86(0x33, &r, &r);
			r.x.cx=(r.x.cx>>3)+1;
			r.x.dx=(r.x.dx>>3)+1;
			/* Left button */
			if ((r.x.bx==1) && (r.x.cx>=(x1+1)) && (r.x.cx<=(x1+3)))
			{
				x=(r.x.dx-y1)/separation;
				if ((x>=0) && (x<noptions))
				{
					y=x;
					tecla=0x5200;
				}
			}
			/* Right button */
			else if (r.x.bx==2)
				tecla=0x3B00;
		}
		while ((tecla!=0x0F00) && (tecla!=0x0F09) && (tecla!=0x3920) &&
					 (tecla!=0x5200) && (tecla!=0x011B) && (tecla!=0x1C0D) &&
					 (tecla!=0x3B00));
		/* Mouse hidde */
		r.x.ax=2;
		int86(0x33, &r, &r);
		if (tecla==0x0F00)        /* Shift-Tab */
			y--;
		else if (tecla==0x0F09)   /* Tab */
			y++;
		else if ((tecla==0x3920) || (tecla==0x5200))  /* Space/Ins */
		{
			if (sel[y]=='X')
				sel[y]=' ';
			else
				sel[y]='X';
			y++;
		}
		if (y>noptions-1)
			y=0;
		else if (y<0)
			y=noptions-1;
		textattr(atr0);
		for (x=0; x!=noptions; x++)
		{
			gotoxy(x1, y1+x*separation);
			cprintf("[%c] %s", sel[x], menu[x]);
		}
		textattr(atr1);
		gotoxy(x1, y1+y*separation);
		cprintf("[%c] %s", sel[y], menu[y]);
		textattr(7*16+0);
		gotoxy(1, 25);
		cputs(desc[y]);
	}
	while ((tecla!=0x1C0D) && (tecla!=0x011B) && (tecla!=0x3B00));
	if (tecla==0x3B00)
		return(255);
	else
		return(0);
}

/* ------------------------ Hace un men de botones ----------------------- */
unsigned char pascal property (unsigned char x1, unsigned char y1, unsigned char atr0, unsigned char atr1, char menu[][21], char desc[][71], char *sel, unsigned char noptions, unsigned char separation, unsigned char activado)
{
	register char y;
	register unsigned int tecla;
	char x;
	union REGS r;

	textattr(atr0);
	for (y=0; y!=noptions; y++)
	{
		gotoxy(x1, y1+y*separation);
		cprintf("(%c) %s", sel[y], menu[y]);
	}
	if (activado==0)
		return(0);
	textattr(atr1);
	gotoxy(x1, y1);
	cprintf("(%c) %s", sel[0], menu[0]);
	textattr(7*16+0);
	gotoxy(1, 25);
	cputs(desc[0]);
	y=0;
	do
	{
		/* Mouse show */
		r.x.ax=1;
		int86(0x33, &r, &r);
		do
		{
			watch();
			tecla=bioskey(1);
			if (tecla!=0)
				tecla=bioskey(0);
			/* Get mouse */
			r.x.ax=3;
			int86(0x33, &r, &r);
			r.x.cx=(r.x.cx>>3)+1;
			r.x.dx=(r.x.dx>>3)+1;
			/* Left button */
			if ((r.x.bx==1) && (r.x.cx>=(x1+1)) && (r.x.cx<=(x1+3)))
			{
				x=(r.x.dx-y1)/separation;
				if ((x>=0) && (x<noptions))
				{
					y=x;
					tecla=0x5200;
				}
			}
			/* Right button */
			else if (r.x.bx==2)
				tecla=0x3B00;
		}
		while ((tecla!=0x0F00) && (tecla!=0x0F09) && (tecla!=0x3920) &&
					 (tecla!=0x5200) && (tecla!=0x011B) && (tecla!=0x1C0D) &&
					 (tecla!=0x3B00));
		/* Mouse hidde */
		r.x.ax=2;
		int86(0x33, &r, &r);
		if (tecla==0x0F00)        /* Shift-Tab */
			y--;
		else if (tecla==0x0F09)   /* Tab */
			y++;
		else if ((tecla==0x3920) || (tecla==0x5200))  /* Space/Ins */
		{
			memset(sel, ' ', noptions);
			sel[y]='';
		}
		if (y>noptions-1)
			y=0;
		else if (y<0)
			y=noptions-1;
		textattr(atr0);
		for (x=0; x!=noptions; x++)
		{
			gotoxy(x1, y1+x*separation);
			cprintf("(%c) %s", sel[x], menu[x]);
		}
		textattr(atr1);
		gotoxy(x1, y1+y*separation);
		cprintf("(%c) %s", sel[y], menu[y]);
		textattr(7*16+0);
		gotoxy(1, 25);
		cputs(desc[y]);
	}
	while ((tecla!=0x1C0D) && (tecla!=0x011B) && (tecla!=0x3B00));
	if (tecla==0x3B00)
		return(255);
	else
		return(0);
}

/* -------------------------- Dibuja una ventana --------------------------- */
void pascal box (unsigned char x1, unsigned char y1, unsigned char x2, unsigned char y2, unsigned char atr, char *tipo, char *titulo, unsigned char sombra)
{
	register unsigned char x, y;
	unsigned int c1, c2;
	char l1[82], l2[82], l3[82], tmp[330];

	/* Shadow */
	if (sombra&1)
	{
		gettext(x1+2, y2+1, x2+2, y2+1, tmp);
		c2=(((x2+2)-(x1+2)+1)*((y2+1)-(y2+1)+1))<<1;
		for (c1=1; c1<=c2; c1+=2)
			tmp[c1]=8;
		puttext(x1+2, y2+1, x2+2, y2+1, tmp);
		gettext(x2+1, y1+1, x2+2, y2+1, tmp);
		c2=(((x2+2)-(x2+1)+1)*((y2+1)-(y1+1)+1))<<1;
		for (c1=1; c1<=c2; c1+=2)
			tmp[c1]=8;
		puttext(x2+1, y1+1, x2+2, y2+1, tmp);
	}
	/* No window */
	if ((sombra&4)==0)
	{
		x=(x2-x1);
		memset(&l1, 0, x+2);
		memset(&l2, 0, x+2);
		memset(&l3, 0, x+2);
		l1[0]=tipo[0];
		memset(&l1[1], tipo[2], x-1);
		l1[x]=tipo[1];
		l2[0]=tipo[4];
		memset(&l2[1], 32, x-1);
		l2[x]=tipo[4];
		l3[0]=tipo[5];
		memset(&l3[1], tipo[3], x-1);
		l3[x]=tipo[6];
		textattr(atr);
		gotoxy(x1, y1);
		cputs(l1);
		if (titulo[0]!=0)
		{
			sprintf(tmp, " %s ", titulo);
			cputsc(x1, x2, y1, tmp);
		}
		/* Close */
		if (sombra&2)
		{
			gotoxy(x1+2, y1);
			cputs("[]");
		}
		for (y=y1+1; y!=y2; y++)
		{
			gotoxy(x1, y);
			cputs(l2);
		}
		gotoxy(x1, y2);
		cputs(l3);
	}
}

/* ------------------- Rutina de control de errores ----------------------- */
void interrupt error (unsigned int bp, unsigned int di, unsigned int si, unsigned int ds, unsigned int es, unsigned int dx, unsigned int cx, unsigned int bx, unsigned int ax)
{
	register unsigned int err;
	unsigned char oldx, oldy;
  char *oldb;
	char butt[][11]= {"[Probar]", "[Fallar]", "[Ignorar]", "[Abortar]"};
	char desc[][71]= {"Reintenta el proceso que ha causado el error                        ",
										"Falla el proceso que ha causado el error                            ",
										"Ignorar el error ocurrido y continua con la ejecucin               ",
										"Termina la ejecucin del programa                                   "};

	err=di & 0x00FF;
	oldb=malloc(2000);
	if (oldb==0)
		return;
	oldx=wherex();
	oldy=wherey();
  gettext(8, 10, 70, 16, oldb);
	box(8, 10, 68, 15, 4*16+15, "ɻͺȼ" , "Error", 1);
	cputsc(8, 68, 11, "Ha ocurrido un error");
	if (err==0x00)
		cputsc(8, 68, 12, "Disco protegido contra escritura");
	else if (err==0x01)
		cputsc(8, 68, 12, "Unidad desconocida");
	else if (err==0x02)
		cputsc(8, 68, 12, "Unidad no preparada");
  else if (err==0x03)
		cputsc(8, 68, 12, "Comando desconocido");
	else if (err==0x04)
		cputsc(8, 68, 12, "Error de datos");
	else if (err==0x05)
		cputsc(8, 68, 12, "Logitud de estructura incorrecta");
	else if (err==0x06)
		cputsc(8, 68, 12, "Error de bsqueda");
	else if (err==0x07)
		cputsc(8, 68, 12, "Tipo de dispositivo desconocido");
	else if (err==0x08)
		cputsc(8, 68, 12, "Sector no encontrado");
	else if (err==0x09)
		cputsc(8, 68, 12, "Impresora sin papel");
	else if (err==0x0A)
		cputsc(8, 68, 12, "Fallo de escritura");
	else if (err==0x0B)
		cputsc(8, 68, 12, "Fallo de lectura");
	else if (err==0x0C)
		cputsc(8, 68, 12, "Fallo general");
	err=buttons (14, 14, 4*16+15, 2*16+15, butt, desc, 4, 14);
	gotoxy(oldx, oldy);
  puttext(8, 10, 70, 16, oldb);
  free(oldb);
  if (err==0)
		ax=1;
	else if (err==1)
		ax=3;
	else if (err==2)
		ax=0;
	else if (err==3)
		ax=2;
#pragma warn -par
}
#pragma warn .par

/* -------------------------- Visualiza un texto --------------------------- */
unsigned char pascal view (unsigned char x1, unsigned char y1, unsigned char x2, unsigned char y2, unsigned char atr0, unsigned char atr1, char buffer[][61], unsigned char ultimo, char *titulo)
{
	register unsigned char z, c;
	unsigned char oldx, oldy;
	int f, ini;
	unsigned int tecla;
	char *oldb;
	union REGS r;
	char tmp[70];

	oldb=malloc(textsize(x1, y1, x2+2, y2+1));
	if (oldb==0)
		return(0);
	oldx=wherex();
	oldy=wherey();
	gettext(x1, y1, x2+2, y2+1, oldb);
	for (f=ultimo; f!=ultimo+y2-y1; f++)
		buffer[f][0]=0;
	textattr(7*16+0);
	gotoxy(1, 25);
	cputs("ENTER and ESC cierran la ventana; cursores y pginas mueven         ");
	box(x1, y1, x2, y2, atr0, "ɻͺȼ" , titulo, 3);
	gotoxy(x2, y1+1);
	putch(24);
	gotoxy(x2, y2-1);
	putch(25);
	textattr(atr0);
	for (z=y1+2; z!=y2-1; z++)
	{
		gotoxy (x2, z);
		putch('');
	}
	z=0;
	ini=0;
	do
	{
		textattr(atr0);
		gotoxy (x2, z+y1+2);
		putch('');
		c=y1+1;
		textattr(atr1);
		for (f=ini; f!=ini+y2-y1-1; f++)
		{
			memset(tmp, 0, 61);
			memset(tmp, 32, 60);
			memcpy (tmp, &buffer[f], strlen(buffer[f]));
			gotoxy(x1+2, c);
			cputs(tmp);
			c++;
		}
		/* Mouse show */
		r.x.ax=1;
		int86(0x33, &r, &r);
		do
		{
			watch();
			tecla=bioskey(1);
			if (tecla!=0)
				tecla=bioskey(0);
			/* Get mouse */
			r.x.ax=3;
			int86(0x33, &r, &r);
			r.x.cx=(r.x.cx>>3)+1;
			r.x.dx=(r.x.dx>>3)+1;
			/* Left button */
			if (r.x.bx==1)
			{
				if (r.x.cx==x2)
				{
					if (r.x.dx==y1+1)
						tecla=0x4800;
					else if (r.x.dx==y2-1)
						tecla=0x5000;
					else if ((r.x.dx>=y1+2) && (r.x.dx<=y2-2) && (r.x.cx==x2))
					{
						ini=(r.x.dx-y1-2)*ultimo/(y2-y1-4);
						tecla=0x1312;
					}
				}
				else if ((r.x.cx==x1+3) && (r.x.dx==y1))
					tecla=0x011B;
			}
			/* Right button */
			else if (r.x.bx==2)
				tecla=0x3B00;
		}
		while ((tecla!=0x4800) && (tecla!=0x5000) && (tecla!=0x4900) &&
					 (tecla!=0x5100) && (tecla!=0x4700) && (tecla!=0x4F00) &&
					 (tecla!=0x011B) && (tecla!=0x1C0D) && (tecla!=0x1312) &&
					 (tecla!=0x3B00));
		/* Mouse hidde */
		r.x.ax=2;
		int86(0x33, &r, &r);
		if (tecla==0x4800)       /* Up */
			ini--;
		else if (tecla==0x5000)  /* Dw */
			ini++;
		else if (tecla==0x4900)  /* PgUp */
			ini-=(y2-y1)-2;
		else if (tecla==0x5100)  /* PgDw */
			ini+=(y2-y1)-2;
		else if (tecla==0x4700)  /* Org */
			ini=0;
		else if (tecla==0x4F00)  /* End */
			ini=ultimo;
		if (ini<0)
			ini=0;
		else if (ini>ultimo)
			ini=ultimo;
		textattr(atr0);
		gotoxy(x2, z+y1+2);
		putch('');
		z=(ini*(y2-y1-4))/ultimo;
		gotoxy(x2, z+y1+2);
		putch('');
	}
	while ((tecla!=0x011B) && (tecla!=0x1C0D) && (tecla!=0x3B00));
	puttext(x1, y1, x2+2, y2+1, oldb);
	free(oldb);
	gotoxy(oldx, oldy);
	if (tecla==0x3B00)
		return(255);
	else
		return(0);
}

/* --------------------------- Funcin inicial ---------------------------- */
void _fastcall hello (char *nombre)
{
	unsigned char oldx, oldy;
	FILE *f;
	char *oldb;
	void interrupt (*oldvect)();
  union REGS r;

	oldb=malloc(4000);
	if (oldb==0)
		return;
	gettext(1, 1, 80, 25, oldb);
	oldx=wherex();
	oldy=wherey();
	_setcursortype(_NOCURSOR);
	textattr(7);
	setpal(1);
	empuja();
	background(1);
	/* Mouse reset */
	r.x.ax=0;
	int86(0x33, &r, &r);
  oldvect=getvect(0x24);
	setvect(0x24, error);
	f=fopen(nombre, "wb");
	if (f==0)
		return;
	fwrite(oldb, 1, 4000, f);
	fwrite(&oldx, 1, 1, f);
	fwrite(&oldy, 1, 1, f);
	fwrite(&oldvect, 1, sizeof(oldvect), f);
	fclose(f);
	free(oldb);
  about();
}

/* --------------------------- Funcin final ------------------------------ */
void _fastcall bye (char *nombre, unsigned char e)
{
	unsigned char oldx, oldy;
	FILE *f;
	char *oldb;
	void interrupt (*oldvect)();

	oldb=malloc(4000);
	if (oldb==0)
		return;
	f=fopen(nombre, "rb");
	if (f==0)
		return;
	fread(oldb, 1, 4000, f);
	fread(&oldx, 1, 1, f);
	fread(&oldy, 1, 1, f);
	fread(&oldvect, 1, sizeof(oldvect), f);
	fclose(f);
	remove(nombre);
	setvect(0x24, oldvect);
	puttext(1, 1, 80, 25, oldb);
  if (oldy<25-12)
	{
		box(1, 1, 78, 11, 0*16+14, "ڿĳ", "Gracias por utilizar", 1);
		textattr(0*16+3);
		window(3, 2, 76, 10);
	}
	else
	{
		box(1, 2, 78, 12, 0*16+14, "ڿĳ", "Gracias por utilizar", 1);
		textattr(0*16+3);
		window(3, 3, 76, 11);
	}
	gotoxy(1, 1);
	cputs("COM2COM v1.0 para DOS\r\n");
	cputs("\r\n\r\n");
	cputs("Prctica de Xarxes de Computadors (XACO)\r\n"); 
	cputs("\r\n");
	cputs("(c) Copyright 1998 por Javier Gutirrez Chamorro\r\n");
	cputs("                       Guti@bbs-ce.uab.es\r\n");
	textattr(0*16+12);
	cputs("Todos los derechos reservados.");
	window(1, 1, 80, 25);
	rebota(); 
	if (oldy<12)
		gotoxy(oldx, 12);
	else
		gotoxy(oldx, oldy);
	_setcursortype(_NORMALCURSOR);
	textattr(7);
  setpal(0);
	free(oldb);
	exit(e);
}

/* --------------- Dibuja en pantalla la ventana del about ---------------- */
void _fastcall background (unsigned char e)
{
	register unsigned int i;
	unsigned int *oldb, *olda;

	oldb=malloc(4000);
	if (oldb==0)
		return;
	olda=oldb;

	for (i=0; i!=2000-160; i++)
	{
		*olda=0x13B0;
		olda++;
	}
	puttext(1, 2, 80, 24, oldb);
	if (e==1)
	{
		textattr(7*16+0);
		gotoxy(1, 1);
		cputs("COM2COM v1.0 para DOS               (c) Copyright 1998 Javier Gutirrez Chamorro");
		olda=oldb;
		for (i=0; i!=80; i++)
		{
			*olda=0x7020;
			olda++;
		}
		puttext(1, 25, 80, 25, oldb);
	}
	free(oldb);
}

/* --------------- Dibuja en pantalla la ventana del about ---------------- */
void _fastcall about (void)
{
  register unsigned int tecla;
	char x1=9, y1=5, x2=68, y2=18;

	unsigned char oldx, oldy;
	char *oldb;
  union REGS r;

	oldb=malloc(textsize(x1, y1, x2+2, y2+1));
	if (oldb==0)
		return;
	oldx=wherex();
	oldy=wherey();
  move:
	gettext(x1, y1, x2+2, y2+1, oldb);
  textattr(7*16+0);
	gotoxy(1, 25);
	cputs("ENTER and ESC cierran la ventana; cursores y pginas mueven         ");
	box (x1, y1, x2, y2, 7*16+15, A_DOUBLE, "Sobre", 3);
	textattr(7*16+0);
	cputsc(x1, x2, y1+1,	"COM2COM para DOS");
	cputsc(x1, x2, y1+2,	"Version  1.0");
	cputsc(x1, x2, y1+5,  "Prctica de Xarxes de Computadors (XACO)");
	cputsc(x1, x2, y1+9, 	"(c) Copyright 1998 por Javier Gutierrez Chamorro ");
	cputsc(x1, x2, y1+10, 	"                        Guti@bbs-ce.uab.es        ");
	textattr(7*16+4);
	cputsc(x1, x2, y1+12, "Todos los derechos reservados");
	/* Mouse show */
	r.x.ax=1;
	int86(0x33, &r, &r);
  do
  {
		watch();
		tecla=bioskey(1);
    if (tecla!=0)
			tecla=bioskey(0);
    /* Get mouse */
    r.x.ax=3;
    int86(0x33, &r, &r);
    r.x.cx=(r.x.cx>>3)+1;
    r.x.dx=(r.x.dx>>3)+1;
    /* Left button */
    if (r.x.bx==1)
    {
			if ((r.x.dx==y1) && (r.x.cx==x1+3))
       tecla=0x011B;
    }
  }
	while ((tecla!=0x1C0D) && (tecla!=0x011B));
  /* Mouse hidde */
  r.x.ax=2;
  int86(0x33, &r, &r);
  gotoxy(oldx, oldy);
	puttext(x1, y1, x2+2, y2+1, oldb);
	free(oldb);
}

/* -------------------- Deja o no introducir al usuario ------------------- */
void _fastcall screensaver (void)
{
  register unsigned char i, j;
  unsigned char k;
  unsigned char oldx, oldy;
  unsigned char rep[8][5];
  char oldb[8][5][10*5*2];

  oldx=wherex();
	oldy=wherey();
	randomize();
  /* Guardar pantalla original */
  for (j=0; j!=5; j++)
  {
    for (i=0; i!=8; i++)
			gettext(i*10+1, j*5+1, i*10+10, j*5+5, oldb[i][j]);
  }
  ini:
  /* Empezar a quitar */
  memset(&rep, 0, sizeof(rep));
  for (k=0; k!=40; k++)
  {
    i=bioskey(1);
    if (i!=0)
    {
      bioskey(0);
      goto fin;
    }
    do
    {
      i=random(8);
      j=random(5);
    }
		while (rep[i][j]);
    rep[i][j]=1;
		window(i*10+1, j*5+1, i*10+10, j*5+5);
    textattr(0);
    clrscr();
    window(1, 1, 80, 25);
    delay(200);
  }
  /* Empezar a poner */
  memset(&rep, 0, sizeof(rep));
  for (k=0; k!=40; k++)
  {
    i=bioskey(1);
    if (i!=0)
    {
      bioskey(0);
      goto fin;
    }
    do
    {
      i=random(8);
      j=random(5);
    }
		while (rep[i][j]);
    rep[i][j]=1;
		puttext(i*10+1, j*5+1, i*10+10, j*5+5, oldb[i][j]);
    delay(200);
  }
  goto ini;
  fin:
  /* Restaurar pantalla original */
  for (j=0; j!=5; j++)
  {
		for (i=0; i!=8; i++)
			puttext(i*10+1, j*5+1, i*10+10, j*5+5, oldb[i][j]);
  }
  gotoxy(oldx, oldy);
}

/* -------------------- Deja o no introducir al usuario ------------------- */
void _fastcall rebota (void)
{
  register unsigned char i, j;
  char oldb[4000];

	window(1,1,80,25);
  gettext(1, 1, 80, 25, oldb);
	textattr(7);
	clrscr();

  for (j=27; j!=0; j--)
	{
    for (i=1; i!=j; i++)
		{
      puttext(1, i, 80, i+24, oldb);
      gotoxy(1, i);
			clreol();
			/* delay(30); */
		}
    for (i=j; i!=0; i--)
		{
      puttext(1, i, 80, i+24, oldb);
      gotoxy(1, i);
			clreol();
			/* delay(30); */
		}
	}
  puttext(1, 1, 80, 25, oldb);
}

/* -------------------- Deja o no introducir al usuario ------------------- */
unsigned char _fastcall exittodos (void)
{
  register unsigned int i;
  unsigned char oldx, oldy;
  char *oldb, *buf;
	char but1[][11]={   "[Si]", "[No]", "[Shell]"};
	char dbut1[][71]={  "Sale al DOS y acaba el programa                                     ",
											"Continua ejecutando el programa                                     ",
											"Sale al DOS y continua ejecutando el programa                       "};

  oldx=wherex();
  oldy=wherey();
  oldb=malloc(textsize(20, 10, 62, 15));
  if (oldb==0)
		return(255);
  gettext(20, 10, 62, 15, oldb);
	box(20, 10, 60, 14, 16*7+15, A_DOUBLE, "Salir", SHADOW);
	textattr(16*7+0);
	cputsc(20, 60, 11, "Seguro que desea salir al DOS?");
  do
  {
		i=buttons(24, 13, 7*16+0, 2*16+15, but1, dbut1, 3, 13);
	}
  while (i==255);
  puttext(20, 10, 62, 15, oldb);
  free(oldb);
  gotoxy(oldx, oldy);
  if (i==2)
  {
		shell(3, 2, 75, 22, "");
    i=1;
	}
	return(i);
}

/* ------------ Escribe en pantalla el estado de los bloqueos ------------- */
void _fastcall shell (unsigned char x1, unsigned char y1, unsigned char x2, unsigned char y2, char *comando)
{
  register unsigned char i;

  unsigned char oldx, oldy;
  char *oldb;
	void interrupt (*oldvect)();

  oldx=wherex();
  oldy=wherey();
  oldb=malloc(textsize(x1, y1, x2+2, y2+1));
  if (oldb==0)
		return;
  gettext(x1, y1, x2+2, y2+1, oldb);
  if (comando[0]==0)
		box(x1, y1, x2, y2, 14, A_DOUBLE, "Shell al DOS", SHADOW);
  else
    box(x1, y1, x2, y2, 14, A_DOUBLE, comando, SHADOW);
	window(x1+1, y1+1, x2-1, y2-1);
	textattr(15);
	clrscr();
	cputs("Escriba 'EXIT' para volver\r\n\r\n");
	textattr(7);
  _setcursortype(_NORMALCURSOR);
  oldvect=getvect(0x29);
  setvect(0x29, shell_patch);
	i=system(comando);
	setvect(0x29, oldvect);
	if (i!=0)
	{
		textattr(15);
		cputs("No se puede ejecutar el programa.");
	}
  _setcursortype(_NOCURSOR);
	window(1, 1, 80, 25);
	puttext(x1, y1, x2+2, y2+1, oldb);
	free(oldb);
	gotoxy(oldx, oldy);
}

/* ------------------- Rutina de control de errores ----------------------- */
void interrupt shell_patch (unsigned int bp, unsigned int di, unsigned int si, unsigned int ds, unsigned int es, unsigned int dx, unsigned int cx, unsigned int bx, unsigned int ax)
{
	register unsigned char al;

  al=ax&255;
  putch(al);
#pragma warn -par
}
#pragma warn .par
