#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <bios.h>
#include <dos.h>
#include "comlib.h"

unsigned char configuracion_puerto;
struct configuracion
{
	unsigned datos:2;
	unsigned parada:1;
	unsigned paridad:2;
	unsigned velocidad:3;
} configuracion;



void _fastcall configurar (void);
void _fastcall hacer (void);


void main (void)
{
	hello("COM2COM.TMP");
	configurar();
	hacer();
  bye("COM2COM.TMP", 0);
}

void _fastcall configurar (void)
{
	register unsigned int i;
	unsigned char oldx, oldy, tmp;
	char *oldb1, *oldb2;
	char mpuerto[][21]={"COM1",
											"COM2",
											"COM3",
											"COM4"};
	char dpuerto[][71]={"Fija el puerto en COM1                                              ",
											"Fija el puerto en COM2                                              ",
											"Fija el puerto en COM3                                              ",
											"Fija el puerto en COM4                                              "};
	char spuerto[]={'', ' ', ' ', ' '};
	char mvelocidad[][21]={"110 bps",
												 "150 bps",
												 "300 bps",
												 "600 bps",
												 "1200 bps",
												 "2400 bps",
												 "4800 bps",
												 "9600 bps"};
	char dvelocidad[][71]={"Fija la velocidad a 110 bps                                         ",
												 "Fija la velocidad a 150 bps                                         ",
												 "Fija la velocidad a 300 bps                                         ",
												 "Fija la velocidad a 600 bps                                         ",
												 "Fija la velocidad a 1200 bps                                        ",
												 "Fija la velocidad a 2400 bps                                        ",
												 "Fija la velocidad a 4800 bps                                        ",
												 "Fija la velocidad a 9600 bps                                        "};
	char svelocidad[]={' ', ' ', ' ', ' ', ' ', ' ', ' ', ''};
	char mdatos[][21]={"5 bits",
										 "6 bits",
										 "7 bits",
										 "8 bits"};
	char ddatos[][71]={"Fija los datos a 5 bits                                              ",
										 "Fija los datos a 6 bits                                              ",
										 "Fija los datos a 7 bits                                              ",
										 "Fija los datos a 8 bits                                              "};
	char sdatos[]={' ', ' ', ' ', ''};
	char mparada[][21]={"1 bit",
											"2 bits"};
	char dparada[][71]={"Fija los bits de parada a 1                                         ",
											"Fija los bits de parada a 2                                         "};
	char sparada[]={'', ' '};
	char mparidad[][21]={"Ninguna",
											 "Impar",
											 "Par"};
	char dparidad[][71]={"Fija la paridad a ninguna                                           ",
											 "Fija la paridad impar                                               ",
											 "Fija la paridad par                                                 "};
	char sparidad[]={'', ' ', ' '};
	oldx=wherex();
	oldy=wherey();
	oldb1=malloc(textsize(8, 3, 70, 7));
	if (oldb1==0)
		return;
	oldb2=malloc(textsize(18, 9, 60, 20));
	if (oldb2==0)
		return;

	gettext(8, 3, 70, 7, oldb1);
	box(8, 3, 68, 6, 16*3+15, A_DOUBLE, "Puertos", SHADOW);
	textattr(16*3+0);
	gotoxy(15, 4);
	cprintf("COM1: %04X; COM2: %04X; COM3: %04X; COM4: %04X", 100, 200, 300, 400);

	gettext(18, 9, 60, 20, oldb2);
	box(18, 9, 58, 15, 16*3+15, A_DOUBLE, "Puerto", SHADOW);
	textattr(16*3+0);
	cputsc(10, 68, 10, "Elija el puerto");
	i=property(35, 11, 16*3+0, 16*2+15, mpuerto, dpuerto, spuerto, 4, 1, 1);
	for (i=0; i!=4; i++)
	{
		if (spuerto[i]!=' ')
			break;
	}
	configuracion_puerto=i;
	puttext(18, 9, 60, 20, oldb2);

	box(18, 9, 58, 19, 16*3+15, A_DOUBLE, "Velocidad", SHADOW);
	textattr(16*3+0);
	cputsc(10, 68, 10, "Elija la velocidad");
	property(35, 11, 16*3+0, 16*2+15, mvelocidad, dvelocidad, svelocidad, 8, 1, 1);
	for (i=0; i!=8; i++)
	{
		if (svelocidad[i]!=' ')
			break;
	}
	configuracion.velocidad=i;
	puttext(18, 9, 60, 20, oldb2);

	box(18, 9, 58, 17, 16*3+15, A_DOUBLE, "Datos", SHADOW);
	textattr(16*3+0);
	cputsc(10, 68, 10, "Elija los bits de datos");
	i=property(35, 11, 16*3+0, 16*2+15, mdatos, ddatos, sdatos, 4, 1, 1);
	for (i=0; i!=4; i++)
	{
		if (sdatos[i]!=' ')
			break;
	}
	configuracion.datos=i;
	puttext(18, 9, 60, 20, oldb2);

	box(18, 9, 58, 16, 16*3+15, A_DOUBLE, "Parada", SHADOW);
	textattr(16*3+0);
	cputsc(10, 68, 10, "Elija los bits de parada");
	i=property(35, 11, 16*3+0, 16*2+15, mparada, dparada, sparada, 2, 1, 1);
	for (i=0; i!=2; i++)
	{
		if (sparada[i]!=' ')
			break;
	}
	configuracion.parada=i;
	puttext(18, 9, 60, 20, oldb2);


	if (configuracion.datos!=3)
	{
		box(18, 9, 58, 16, 16*3+15, A_DOUBLE, "Paridad", SHADOW);
		textattr(16*3+0);
		cputsc(10, 68, 10, "Elija la paridad");
		i=property(35, 11, 16*3+0, 16*2+15, mparidad, dparidad, sparidad, 3, 1, 1);
		for (i=0; i!=3; i++)
		{
			if (sparidad[i]!=' ')
				break;
		}
		if (i==2)
			configuracion.paridad=3;
		else
			configuracion.paridad=i;
	}
	else
		configuracion.paridad=0;

	puttext(18, 9, 60, 20, oldb2);

	memcpy(&tmp, &configuracion, 1);
	i=bioscom(0, tmp, configuracion_puerto);
	//i=bioscom(0, 0x80 | 0x02 | 0x00 | 0x00, configuracion_puerto);
	//i=bioscom(0, 135, 1); /* 1200,n,8,2 */
	//i=i >> 8;
	//if (i!=0)
	//{
		/* Error al configurar el puerto */
	//}
	puttext(8, 3, 70, 7, oldb1);
	gotoxy(oldx, oldy);
	free(oldb1);
	free(oldb2);
}

void _fastcall hacer (void)
{
	register unsigned int tecla, estado;
	unsigned int entrada, salida;
	unsigned char oldx, oldy;
	char *oldb;

	unsigned char x1=1, x2=1, y1=1, y2=1;

	oldx=wherex();
	oldy=wherey();
	oldb=malloc(textsize(3, 3, 78, 23));
	if (oldb==0)
		return;
	gettext(3, 3, 78, 23, oldb);

	box(3, 3, 76, 12, 16*1+15, A_SINGLE, "Local", SHADOW);
	box(3, 13, 76, 22, 16*1+15, A_SINGLE, "Remoto", SHADOW);
	textattr(7*16+0);
	gotoxy(1, 25);
	cputs("F-2: Configurar  ESC: Salir                                        ");
	do
	{
		/* Recibir */
		salida=bioscom(2, NULL, configuracion_puerto) & 0xFF;
		if (salida!=0)
		{
			window(4, 14, 75, 21);
			textattr(16*1+14);
			gotoxy(x2, y2);
			if (salida==13)
				cputs("\r\n");
			else if (salida=='\b')
				cputs("\b \b");
			else
				putch(salida);
			x2=wherex();
			y2=wherey();
		}
		if (bioskey(1))
		{
			/* Enviar */
			entrada=bioskey(0);
			if (entrada==KBD_ESC)
			{
				tecla=exittodos()+KBD_ESC;
				textattr(7*16+0);
				gotoxy(1, 25);
				cputs("F-2: Configurar  ESC: Salir                                        ");
			}
			else if (entrada==KBD_F2)
			{
				configurar();
				textattr(7*16+0);
				gotoxy(1, 25);
				cputs("F-2: Configurar  ESC: Salir                                        ");
			}
			else
			{
				window(4, 4, 75, 11);
				textattr(16*1+14);
				gotoxy(x1, y1);
				if (entrada==KBD_ENTER)
					cputs("\r\n");
				else
					putch((char) entrada);
				x1=wherex();
				y1=wherey();
				bioscom(1, (char) entrada, configuracion_puerto);
			}
		}
		else
		{
			bioscom(1, 0, configuracion_puerto);
		}
		window(1, 1, 80, 25);
		blocks();
	}
	while (tecla!=KBD_ESC);
	puttext(3, 3, 78, 23, oldb);
	gotoxy(oldx, oldy);
	free(oldb);
}
